(function() {
  const plugin = new window.springroll.ContainerPlugin();

  const unmute = function() {
    // if this game is using springroll.Sound, ensure that it's unmuted
    const localSpringroll = this.dom.contentWindow.springroll;
    if (localSpringroll && localSpringroll.Sound && localSpringroll.Sound.instance) {
      localSpringroll.Sound.instance.systemMuted = false;
    }
  };

  plugin.open = function() {
    // specifically listen for the loadDone event that SpringRoll 0.3 games emit so they also get unmuted
    this.client.on('loadDone', unmute.bind(this));
  };

  plugin.opened = unmute;
})();
