(function () {
  'use strict';

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  var runtime_1 = createCommonjsModule(function (module) {
    /**
     * Copyright (c) 2014-present, Facebook, Inc.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */
    var runtime = function (exports) {

      var Op = Object.prototype;
      var hasOwn = Op.hasOwnProperty;
      var undefined$1; // More compressible than void 0.

      var $Symbol = typeof Symbol === "function" ? Symbol : {};
      var iteratorSymbol = $Symbol.iterator || "@@iterator";
      var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
      var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

      function wrap(innerFn, outerFn, self, tryLocsList) {
        // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
        var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
        var generator = Object.create(protoGenerator.prototype);
        var context = new Context(tryLocsList || []); // The ._invoke method unifies the implementations of the .next,
        // .throw, and .return methods.

        generator._invoke = makeInvokeMethod(innerFn, self, context);
        return generator;
      }

      exports.wrap = wrap; // Try/catch helper to minimize deoptimizations. Returns a completion
      // record like context.tryEntries[i].completion. This interface could
      // have been (and was previously) designed to take a closure to be
      // invoked without arguments, but in all the cases we care about we
      // already have an existing method we want to call, so there's no need
      // to create a new function object. We can even get away with assuming
      // the method takes exactly one argument, since that happens to be true
      // in every case, so we don't have to touch the arguments object. The
      // only additional allocation required is the completion record, which
      // has a stable shape and so hopefully should be cheap to allocate.

      function tryCatch(fn, obj, arg) {
        try {
          return {
            type: "normal",
            arg: fn.call(obj, arg)
          };
        } catch (err) {
          return {
            type: "throw",
            arg: err
          };
        }
      }

      var GenStateSuspendedStart = "suspendedStart";
      var GenStateSuspendedYield = "suspendedYield";
      var GenStateExecuting = "executing";
      var GenStateCompleted = "completed"; // Returning this object from the innerFn has the same effect as
      // breaking out of the dispatch switch statement.

      var ContinueSentinel = {}; // Dummy constructor functions that we use as the .constructor and
      // .constructor.prototype properties for functions that return Generator
      // objects. For full spec compliance, you may wish to configure your
      // minifier not to mangle the names of these two functions.

      function Generator() {}

      function GeneratorFunction() {}

      function GeneratorFunctionPrototype() {} // This is a polyfill for %IteratorPrototype% for environments that
      // don't natively support it.


      var IteratorPrototype = {};

      IteratorPrototype[iteratorSymbol] = function () {
        return this;
      };

      var getProto = Object.getPrototypeOf;
      var NativeIteratorPrototype = getProto && getProto(getProto(values([])));

      if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
        // This environment has a native %IteratorPrototype%; use it instead
        // of the polyfill.
        IteratorPrototype = NativeIteratorPrototype;
      }

      var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
      GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
      GeneratorFunctionPrototype.constructor = GeneratorFunction;
      GeneratorFunctionPrototype[toStringTagSymbol] = GeneratorFunction.displayName = "GeneratorFunction"; // Helper for defining the .next, .throw, and .return methods of the
      // Iterator interface in terms of a single ._invoke method.

      function defineIteratorMethods(prototype) {
        ["next", "throw", "return"].forEach(function (method) {
          prototype[method] = function (arg) {
            return this._invoke(method, arg);
          };
        });
      }

      exports.isGeneratorFunction = function (genFun) {
        var ctor = typeof genFun === "function" && genFun.constructor;
        return ctor ? ctor === GeneratorFunction || // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
      };

      exports.mark = function (genFun) {
        if (Object.setPrototypeOf) {
          Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
        } else {
          genFun.__proto__ = GeneratorFunctionPrototype;

          if (!(toStringTagSymbol in genFun)) {
            genFun[toStringTagSymbol] = "GeneratorFunction";
          }
        }

        genFun.prototype = Object.create(Gp);
        return genFun;
      }; // Within the body of any async function, `await x` is transformed to
      // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
      // `hasOwn.call(value, "__await")` to determine if the yielded value is
      // meant to be awaited.


      exports.awrap = function (arg) {
        return {
          __await: arg
        };
      };

      function AsyncIterator(generator) {
        function invoke(method, arg, resolve, reject) {
          var record = tryCatch(generator[method], generator, arg);

          if (record.type === "throw") {
            reject(record.arg);
          } else {
            var result = record.arg;
            var value = result.value;

            if (value && typeof value === "object" && hasOwn.call(value, "__await")) {
              return Promise.resolve(value.__await).then(function (value) {
                invoke("next", value, resolve, reject);
              }, function (err) {
                invoke("throw", err, resolve, reject);
              });
            }

            return Promise.resolve(value).then(function (unwrapped) {
              // When a yielded Promise is resolved, its final value becomes
              // the .value of the Promise<{value,done}> result for the
              // current iteration.
              result.value = unwrapped;
              resolve(result);
            }, function (error) {
              // If a rejected Promise was yielded, throw the rejection back
              // into the async generator function so it can be handled there.
              return invoke("throw", error, resolve, reject);
            });
          }
        }

        var previousPromise;

        function enqueue(method, arg) {
          function callInvokeWithMethodAndArg() {
            return new Promise(function (resolve, reject) {
              invoke(method, arg, resolve, reject);
            });
          }

          return previousPromise = // If enqueue has been called before, then we want to wait until
          // all previous Promises have been resolved before calling invoke,
          // so that results are always delivered in the correct order. If
          // enqueue has not been called before, then it is important to
          // call invoke immediately, without waiting on a callback to fire,
          // so that the async generator function has the opportunity to do
          // any necessary setup in a predictable way. This predictability
          // is why the Promise constructor synchronously invokes its
          // executor callback, and why async functions synchronously
          // execute code before the first await. Since we implement simple
          // async functions in terms of async generators, it is especially
          // important to get this right, even though it requires care.
          previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
        } // Define the unified helper method that is used to implement .next,
        // .throw, and .return (see defineIteratorMethods).


        this._invoke = enqueue;
      }

      defineIteratorMethods(AsyncIterator.prototype);

      AsyncIterator.prototype[asyncIteratorSymbol] = function () {
        return this;
      };

      exports.AsyncIterator = AsyncIterator; // Note that simple async functions are implemented on top of
      // AsyncIterator objects; they just return a Promise for the value of
      // the final result produced by the iterator.

      exports.async = function (innerFn, outerFn, self, tryLocsList) {
        var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList));
        return exports.isGeneratorFunction(outerFn) ? iter // If outerFn is a generator, return the full iterator.
        : iter.next().then(function (result) {
          return result.done ? result.value : iter.next();
        });
      };

      function makeInvokeMethod(innerFn, self, context) {
        var state = GenStateSuspendedStart;
        return function invoke(method, arg) {
          if (state === GenStateExecuting) {
            throw new Error("Generator is already running");
          }

          if (state === GenStateCompleted) {
            if (method === "throw") {
              throw arg;
            } // Be forgiving, per 25.3.3.3.3 of the spec:
            // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume


            return doneResult();
          }

          context.method = method;
          context.arg = arg;

          while (true) {
            var delegate = context.delegate;

            if (delegate) {
              var delegateResult = maybeInvokeDelegate(delegate, context);

              if (delegateResult) {
                if (delegateResult === ContinueSentinel) continue;
                return delegateResult;
              }
            }

            if (context.method === "next") {
              // Setting context._sent for legacy support of Babel's
              // function.sent implementation.
              context.sent = context._sent = context.arg;
            } else if (context.method === "throw") {
              if (state === GenStateSuspendedStart) {
                state = GenStateCompleted;
                throw context.arg;
              }

              context.dispatchException(context.arg);
            } else if (context.method === "return") {
              context.abrupt("return", context.arg);
            }

            state = GenStateExecuting;
            var record = tryCatch(innerFn, self, context);

            if (record.type === "normal") {
              // If an exception is thrown from innerFn, we leave state ===
              // GenStateExecuting and loop back for another invocation.
              state = context.done ? GenStateCompleted : GenStateSuspendedYield;

              if (record.arg === ContinueSentinel) {
                continue;
              }

              return {
                value: record.arg,
                done: context.done
              };
            } else if (record.type === "throw") {
              state = GenStateCompleted; // Dispatch the exception by looping back around to the
              // context.dispatchException(context.arg) call above.

              context.method = "throw";
              context.arg = record.arg;
            }
          }
        };
      } // Call delegate.iterator[context.method](context.arg) and handle the
      // result, either by returning a { value, done } result from the
      // delegate iterator, or by modifying context.method and context.arg,
      // setting context.delegate to null, and returning the ContinueSentinel.


      function maybeInvokeDelegate(delegate, context) {
        var method = delegate.iterator[context.method];

        if (method === undefined$1) {
          // A .throw or .return when the delegate iterator has no .throw
          // method always terminates the yield* loop.
          context.delegate = null;

          if (context.method === "throw") {
            // Note: ["return"] must be used for ES3 parsing compatibility.
            if (delegate.iterator["return"]) {
              // If the delegate iterator has a return method, give it a
              // chance to clean up.
              context.method = "return";
              context.arg = undefined$1;
              maybeInvokeDelegate(delegate, context);

              if (context.method === "throw") {
                // If maybeInvokeDelegate(context) changed context.method from
                // "return" to "throw", let that override the TypeError below.
                return ContinueSentinel;
              }
            }

            context.method = "throw";
            context.arg = new TypeError("The iterator does not provide a 'throw' method");
          }

          return ContinueSentinel;
        }

        var record = tryCatch(method, delegate.iterator, context.arg);

        if (record.type === "throw") {
          context.method = "throw";
          context.arg = record.arg;
          context.delegate = null;
          return ContinueSentinel;
        }

        var info = record.arg;

        if (!info) {
          context.method = "throw";
          context.arg = new TypeError("iterator result is not an object");
          context.delegate = null;
          return ContinueSentinel;
        }

        if (info.done) {
          // Assign the result of the finished delegate to the temporary
          // variable specified by delegate.resultName (see delegateYield).
          context[delegate.resultName] = info.value; // Resume execution at the desired location (see delegateYield).

          context.next = delegate.nextLoc; // If context.method was "throw" but the delegate handled the
          // exception, let the outer generator proceed normally. If
          // context.method was "next", forget context.arg since it has been
          // "consumed" by the delegate iterator. If context.method was
          // "return", allow the original .return call to continue in the
          // outer generator.

          if (context.method !== "return") {
            context.method = "next";
            context.arg = undefined$1;
          }
        } else {
          // Re-yield the result returned by the delegate method.
          return info;
        } // The delegate iterator is finished, so forget it and continue with
        // the outer generator.


        context.delegate = null;
        return ContinueSentinel;
      } // Define Generator.prototype.{next,throw,return} in terms of the
      // unified ._invoke helper method.


      defineIteratorMethods(Gp);
      Gp[toStringTagSymbol] = "Generator"; // A Generator should always return itself as the iterator object when the
      // @@iterator function is called on it. Some browsers' implementations of the
      // iterator prototype chain incorrectly implement this, causing the Generator
      // object to not be returned from this call. This ensures that doesn't happen.
      // See https://github.com/facebook/regenerator/issues/274 for more details.

      Gp[iteratorSymbol] = function () {
        return this;
      };

      Gp.toString = function () {
        return "[object Generator]";
      };

      function pushTryEntry(locs) {
        var entry = {
          tryLoc: locs[0]
        };

        if (1 in locs) {
          entry.catchLoc = locs[1];
        }

        if (2 in locs) {
          entry.finallyLoc = locs[2];
          entry.afterLoc = locs[3];
        }

        this.tryEntries.push(entry);
      }

      function resetTryEntry(entry) {
        var record = entry.completion || {};
        record.type = "normal";
        delete record.arg;
        entry.completion = record;
      }

      function Context(tryLocsList) {
        // The root entry object (effectively a try statement without a catch
        // or a finally block) gives us a place to store values thrown from
        // locations where there is no enclosing try statement.
        this.tryEntries = [{
          tryLoc: "root"
        }];
        tryLocsList.forEach(pushTryEntry, this);
        this.reset(true);
      }

      exports.keys = function (object) {
        var keys = [];

        for (var key in object) {
          keys.push(key);
        }

        keys.reverse(); // Rather than returning an object with a next method, we keep
        // things simple and return the next function itself.

        return function next() {
          while (keys.length) {
            var key = keys.pop();

            if (key in object) {
              next.value = key;
              next.done = false;
              return next;
            }
          } // To avoid creating an additional object, we just hang the .value
          // and .done properties off the next function object itself. This
          // also ensures that the minifier will not anonymize the function.


          next.done = true;
          return next;
        };
      };

      function values(iterable) {
        if (iterable) {
          var iteratorMethod = iterable[iteratorSymbol];

          if (iteratorMethod) {
            return iteratorMethod.call(iterable);
          }

          if (typeof iterable.next === "function") {
            return iterable;
          }

          if (!isNaN(iterable.length)) {
            var i = -1,
                next = function next() {
              while (++i < iterable.length) {
                if (hasOwn.call(iterable, i)) {
                  next.value = iterable[i];
                  next.done = false;
                  return next;
                }
              }

              next.value = undefined$1;
              next.done = true;
              return next;
            };

            return next.next = next;
          }
        } // Return an iterator with no values.


        return {
          next: doneResult
        };
      }

      exports.values = values;

      function doneResult() {
        return {
          value: undefined$1,
          done: true
        };
      }

      Context.prototype = {
        constructor: Context,
        reset: function (skipTempReset) {
          this.prev = 0;
          this.next = 0; // Resetting context._sent for legacy support of Babel's
          // function.sent implementation.

          this.sent = this._sent = undefined$1;
          this.done = false;
          this.delegate = null;
          this.method = "next";
          this.arg = undefined$1;
          this.tryEntries.forEach(resetTryEntry);

          if (!skipTempReset) {
            for (var name in this) {
              // Not sure about the optimal order of these conditions:
              if (name.charAt(0) === "t" && hasOwn.call(this, name) && !isNaN(+name.slice(1))) {
                this[name] = undefined$1;
              }
            }
          }
        },
        stop: function () {
          this.done = true;
          var rootEntry = this.tryEntries[0];
          var rootRecord = rootEntry.completion;

          if (rootRecord.type === "throw") {
            throw rootRecord.arg;
          }

          return this.rval;
        },
        dispatchException: function (exception) {
          if (this.done) {
            throw exception;
          }

          var context = this;

          function handle(loc, caught) {
            record.type = "throw";
            record.arg = exception;
            context.next = loc;

            if (caught) {
              // If the dispatched exception was caught by a catch block,
              // then let that catch block handle the exception normally.
              context.method = "next";
              context.arg = undefined$1;
            }

            return !!caught;
          }

          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i];
            var record = entry.completion;

            if (entry.tryLoc === "root") {
              // Exception thrown outside of any try block that could handle
              // it, so set the completion value of the entire function to
              // throw the exception.
              return handle("end");
            }

            if (entry.tryLoc <= this.prev) {
              var hasCatch = hasOwn.call(entry, "catchLoc");
              var hasFinally = hasOwn.call(entry, "finallyLoc");

              if (hasCatch && hasFinally) {
                if (this.prev < entry.catchLoc) {
                  return handle(entry.catchLoc, true);
                } else if (this.prev < entry.finallyLoc) {
                  return handle(entry.finallyLoc);
                }
              } else if (hasCatch) {
                if (this.prev < entry.catchLoc) {
                  return handle(entry.catchLoc, true);
                }
              } else if (hasFinally) {
                if (this.prev < entry.finallyLoc) {
                  return handle(entry.finallyLoc);
                }
              } else {
                throw new Error("try statement without catch or finally");
              }
            }
          }
        },
        abrupt: function (type, arg) {
          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i];

            if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
              var finallyEntry = entry;
              break;
            }
          }

          if (finallyEntry && (type === "break" || type === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
            // Ignore the finally entry if control is not jumping to a
            // location outside the try/catch block.
            finallyEntry = null;
          }

          var record = finallyEntry ? finallyEntry.completion : {};
          record.type = type;
          record.arg = arg;

          if (finallyEntry) {
            this.method = "next";
            this.next = finallyEntry.finallyLoc;
            return ContinueSentinel;
          }

          return this.complete(record);
        },
        complete: function (record, afterLoc) {
          if (record.type === "throw") {
            throw record.arg;
          }

          if (record.type === "break" || record.type === "continue") {
            this.next = record.arg;
          } else if (record.type === "return") {
            this.rval = this.arg = record.arg;
            this.method = "return";
            this.next = "end";
          } else if (record.type === "normal" && afterLoc) {
            this.next = afterLoc;
          }

          return ContinueSentinel;
        },
        finish: function (finallyLoc) {
          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i];

            if (entry.finallyLoc === finallyLoc) {
              this.complete(entry.completion, entry.afterLoc);
              resetTryEntry(entry);
              return ContinueSentinel;
            }
          }
        },
        "catch": function (tryLoc) {
          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i];

            if (entry.tryLoc === tryLoc) {
              var record = entry.completion;

              if (record.type === "throw") {
                var thrown = record.arg;
                resetTryEntry(entry);
              }

              return thrown;
            }
          } // The context.catch method must only be called with a location
          // argument that corresponds to a known catch block.


          throw new Error("illegal catch attempt");
        },
        delegateYield: function (iterable, resultName, nextLoc) {
          this.delegate = {
            iterator: values(iterable),
            resultName: resultName,
            nextLoc: nextLoc
          };

          if (this.method === "next") {
            // Deliberately forget the last sent value so that we don't
            // accidentally pass it on to the delegate.
            this.arg = undefined$1;
          }

          return ContinueSentinel;
        }
      }; // Regardless of whether this script is executing as a CommonJS module
      // or not, return the runtime object so that we can declare the variable
      // regeneratorRuntime in the outer scope, which allows this module to be
      // injected easily by `bin/regenerator --include-runtime script.js`.

      return exports;
    }( // If this script is executing as a CommonJS module, use module.exports
    // as the regeneratorRuntime namespace. Otherwise create a new empty
    // object. Either way, the resulting object will be used to initialize
    // the regeneratorRuntime variable at the top of this file.
    module.exports);

    try {
      regeneratorRuntime = runtime;
    } catch (accidentalStrictMode) {
      // This module should not be running in strict mode, so the above
      // assignment should always work unless something is misconfigured. Just
      // in case runtime.js accidentally runs in strict mode, we can escape
      // strict mode using a global Function call. This could conceivably fail
      // if a Content Security Policy forbids using Function, but in that case
      // the proper solution is to fix the accidental strict mode problem. If
      // you've misconfigured your bundler to force strict mode and applied a
      // CSP to forbid Function, and you're not willing to fix either of those
      // problems, please detail your unique predicament in a GitHub issue.
      Function("r", "regeneratorRuntime = r")(runtime);
    }
  });

  var regenerator = runtime_1;

  /**
   * Checks if the device is online by performing a network health check to the learning analytics platform
   * @return {Promise} A promise that resolves to true if the device is online, or false if it's offline
   */
  function isOnline() {
    // if the browser knows it's not connected, don't try the health check at all
    if (window.navigator.onLine === false) {
      return Promise.resolve(false);
    }

    var request = new window.XMLHttpRequest();
    var HEALTH_CHECK_URL = 'https://s3.amazonaws.com/tortuga-static/health-check.json';
    return new Promise(function (resolve) {
      // when the request loads, attempt to parse the response text as JSON. It could be that the user is on a LAN which
      // causes network requests to succeed, but respond with a "login to our wifi" page (like at PBS or at most coffee
      // shops).
      request.addEventListener('load', function (event) {
        var responseText = event.target.responseText;

        try {
          JSON.parse(responseText);
          resolve(true);
        } catch (e) {
          resolve(false);
        }
      });
      request.addEventListener('error', function () {
        resolve(false);
      });
      request.open('GET', HEALTH_CHECK_URL);
      request.send();
    });
  }

  // some common functionality that we merge onto every event so that they can be cancelled etc.
  var eventExtras = {
    defaultPrevented: false,
    preventDefault: function preventDefault() {
      this.defaultPrevented = true;
    },
    propagationStopped: false,
    stopPropagation: function stopPropagation() {
      this.propagationStopped = true;
    }
  };

  var EventDispatcher =
  /*#__PURE__*/
  function () {
    function EventDispatcher() {
      _classCallCheck(this, EventDispatcher);

      this._listeners = {};
    }

    _createClass(EventDispatcher, [{
      key: "trigger",
      value: function trigger(type) {
        var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        Object.assign(data, eventExtras);

        if (this._listeners[type] === undefined) {
          return data;
        }

        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = this._listeners[type][Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var listener = _step.value;
            var returnValue = true;

            try {
              returnValue = listener.callback(data);
            } catch (e) {
              console.warn(e);
            }

            if (returnValue === false) {
              data.defaultPrevented = true;
              data.propagationStopped = true;
            }

            if (data.propagationStopped) {
              return data;
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        return data;
      }
    }, {
      key: "once",
      value: function once(name, callback, priority) {
        var _this = this;

        var listener = function listener(data) {
          callback(data);

          _this.off(name, listener);
        };

        return this.on(name, listener, priority);
      }
    }, {
      key: "on",
      value: function on(name, callback) {
        var priority = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;

        if (!Array.isArray(this._listeners[name])) {
          this._listeners[name] = [];
        }

        this._listeners[name].push({
          callback: callback,
          priority: priority
        });

        this._listeners[name].sort(function (first, second) {
          return first.priority - second.priority;
        });
      }
    }, {
      key: "off",
      value: function off(name, callback) {
        if (this._listeners[name] === undefined) {
          return;
        }

        var index = this._listeners[name].map(function (listener) {
          return listener.callback;
        }).indexOf(callback);

        if (index !== -1) {
          this._listeners[name].splice(index, 1);
        }
      }
    }, {
      key: "has",
      value: function has(name, callback) {
        if (!Array.isArray(this._listeners[name])) {
          return false;
        }

        return this._listeners[name].map(function (listener) {
          return listener.callback;
        }).indexOf(callback) > -1;
      }
      /**
       * Strips extra fields that trigger() adds when emitting an event.
       * @param {object} event The event object to have fields stripped from
       * @return {object} A copy of event, with extra event methods and fields stripped.
       */

    }, {
      key: "stripEventMetadata",
      value: function stripEventMetadata(event) {
        var cloned = Object.assign({}, event);

        var _arr = Object.keys(eventExtras);

        for (var _i = 0; _i < _arr.length; _i++) {
          var key = _arr[_i];
          delete cloned[key];
        }

        return cloned;
      }
    }]);

    return EventDispatcher;
  }();

  function t(t, e) {
    if (!(t instanceof e)) throw new TypeError("Cannot call a class as a function");
  }

  function e(t, e) {
    for (var i = 0; i < e.length; i++) {
      var r = e[i];
      r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(t, r.key, r);
    }
  }

  function i(t, i, r) {
    return i && e(t.prototype, i), r && e(t, r), t;
  }

  var r = "undefined" != typeof window ? window : "undefined" != typeof global ? global : "undefined" != typeof self ? self : {};

  function n(t, e) {
    return t(e = {
      exports: {}
    }, e.exports), e.exports;
  }

  var o = n(function (t, e) {
    t.exports = function () {
      function t(t, e) {
        if (this.app = "loki", this.options = e || {}, void 0 !== t && (this.app = t), this.catalog = null, !this.checkAvailability()) throw new Error("indexedDB does not seem to be supported for your environment");
      }

      function e(t) {
        this.db = null, this.initializeLokiCatalog(t);
      }

      return t.prototype.closeDatabase = function () {
        this.catalog && this.catalog.db && (this.catalog.db.close(), this.catalog.db = null);
      }, t.prototype.checkAvailability = function () {
        return !("undefined" == typeof indexedDB || !indexedDB);
      }, t.prototype.loadDatabase = function (t, i) {
        var r = this.app,
            n = this;
        null !== this.catalog && null !== this.catalog.db ? this.catalog.getAppKey(r, t, function (t) {
          if ("function" == typeof i) {
            if (0 === t.id) return void i(null);
            i(t.val);
          } else console.log(t.val);
        }) : this.catalog = new e(function (e) {
          n.catalog = e, n.loadDatabase(t, i);
        });
      }, t.prototype.loadKey = t.prototype.loadDatabase, t.prototype.saveDatabase = function (t, i, r) {
        var n = this.app,
            o = this;

        function s(t) {
          t && !0 === t.success ? r(null) : r(new Error("Error saving database")), o.options.closeAfterSave && o.closeDatabase();
        }

        null !== this.catalog && null !== this.catalog.db ? this.catalog.setAppKey(n, t, i, s) : this.catalog = new e(function (e) {
          o.saveDatabase(t, i, s);
        });
      }, t.prototype.saveKey = t.prototype.saveDatabase, t.prototype.deleteDatabase = function (t, i) {
        var r = this.app,
            n = this;
        null !== this.catalog && null !== this.catalog.db ? this.catalog.getAppKey(r, t, function (t) {
          var e = t.id;
          0 !== e ? n.catalog.deleteAppKey(e, i) : "function" == typeof i && i({
            success: !0
          });
        }) : this.catalog = new e(function (e) {
          n.catalog = e, n.deleteDatabase(t, i);
        });
      }, t.prototype.deleteKey = t.prototype.deleteDatabase, t.prototype.deleteDatabasePartitions = function (t) {
        var e = this;
        this.getDatabaseList(function (i) {
          i.forEach(function (i) {
            i.startsWith(t) && e.deleteDatabase(i);
          });
        });
      }, t.prototype.getDatabaseList = function (t) {
        var i = this.app,
            r = this;
        null !== this.catalog && null !== this.catalog.db ? this.catalog.getAppKeys(i, function (e) {
          for (var i = [], r = 0; r < e.length; r++) i.push(e[r].key);

          "function" == typeof t ? t(i) : i.forEach(function (t) {
            console.log(t);
          });
        }) : this.catalog = new e(function (e) {
          r.catalog = e, r.getDatabaseList(t);
        });
      }, t.prototype.getKeyList = t.prototype.getDatabaseList, t.prototype.getCatalogSummary = function (t) {
        this.app;
        var i = this;
        null !== this.catalog && null !== this.catalog.db ? this.catalog.getAllKeys(function (e) {
          for (var i, r, n, o, s, a = [], l = 0; l < e.length; l++) i = e[l], n = i.app || "", o = i.key || "", s = i.val || "", r = 2 * n.length + 2 * o.length + s.length + 1, a.push({
            app: i.app,
            key: i.key,
            size: r
          });

          "function" == typeof t ? t(a) : a.forEach(function (t) {
            console.log(t);
          });
        }) : this.catalog = new e(function (e) {
          i.catalog = e, i.getCatalogSummary(t);
        });
      }, e.prototype.initializeLokiCatalog = function (t) {
        var e = indexedDB.open("LokiCatalog", 1),
            i = this;
        e.onupgradeneeded = function (t) {
          var e = t.target.result;

          if (e.objectStoreNames.contains("LokiAKV") && e.deleteObjectStore("LokiAKV"), !e.objectStoreNames.contains("LokiAKV")) {
            var i = e.createObjectStore("LokiAKV", {
              keyPath: "id",
              autoIncrement: !0
            });
            i.createIndex("app", "app", {
              unique: !1
            }), i.createIndex("key", "key", {
              unique: !1
            }), i.createIndex("appkey", "appkey", {
              unique: !0
            });
          }
        }, e.onsuccess = function (e) {
          i.db = e.target.result, "function" == typeof t && t(i);
        }, e.onerror = function (t) {
          throw t;
        };
      }, e.prototype.getAppKey = function (t, e, i) {
        var r,
            n = this.db.transaction(["LokiAKV"], "readonly"),
            o = n.objectStore("LokiAKV"),
            s = o.index("appkey"),
            a = t + "," + e,
            l = s.get(a);
        l.onsuccess = (r = i, function (t) {
          var e = t.target.result;
          null == e && (e = {
            id: 0,
            success: !1
          }), "function" == typeof r ? r(e) : console.log(e);
        }), l.onerror = function (t) {
          return function (e) {
            if ("function" != typeof t) throw e;
            t({
              id: 0,
              success: !1
            });
          };
        }(i);
      }, e.prototype.getAppKeyById = function (t, e, i) {
        var r = this.db.transaction(["LokiAKV"], "readonly"),
            n = r.objectStore("LokiAKV"),
            o = n.get(t);

        o.onsuccess = function (t, e) {
          return function (i) {
            "function" == typeof e ? e(i.target.result, t) : console.log(i.target.result);
          };
        }(i, e);
      }, e.prototype.setAppKey = function (t, e, i, r) {
        var n,
            o = this.db.transaction(["LokiAKV"], "readwrite"),
            s = o.objectStore("LokiAKV"),
            a = s.index("appkey"),
            l = t + "," + e,
            h = a.get(l);
        h.onsuccess = function (n) {
          var o = n.target.result;
          null == o ? o = {
            app: t,
            key: e,
            appkey: t + "," + e,
            val: i
          } : o.val = i;
          var a,
              l = s.put(o);
          l.onerror = (a = r, function (t) {
            "function" == typeof a ? a({
              success: !1
            }) : (console.error("LokiCatalog.setAppKey (set) onerror"), console.error(h.error));
          }), l.onsuccess = function (t) {
            return function (e) {
              "function" == typeof t && t({
                success: !0
              });
            };
          }(r);
        }, h.onerror = (n = r, function (t) {
          "function" == typeof n ? n({
            success: !1
          }) : (console.error("LokiCatalog.setAppKey (get) onerror"), console.error(h.error));
        });
      }, e.prototype.deleteAppKey = function (t, e) {
        var i,
            r = this.db.transaction(["LokiAKV"], "readwrite"),
            n = r.objectStore("LokiAKV"),
            o = n.delete(t);
        o.onsuccess = (i = e, function (t) {
          "function" == typeof i && i({
            success: !0
          });
        }), o.onerror = function (t) {
          return function (e) {
            "function" == typeof t ? t({
              success: !1
            }) : (console.error("LokiCatalog.deleteAppKey raised onerror"), console.error(o.error));
          };
        }(e);
      }, e.prototype.getAppKeys = function (t, e) {
        var i,
            r = this.db.transaction(["LokiAKV"], "readonly"),
            n = r.objectStore("LokiAKV"),
            o = n.index("app"),
            s = IDBKeyRange.only(t),
            a = o.openCursor(s);
        a.onsuccess = function (t, e) {
          return function (i) {
            var r = i.target.result;

            if (r) {
              var n = r.value;
              t.push(n), r.continue();
            } else "function" == typeof e ? e(t) : console.log(t);
          };
        }([], e), a.onerror = (i = e, function (t) {
          "function" == typeof i ? i(null) : (console.error("LokiCatalog.getAppKeys raised onerror"), console.error(t));
        });
      }, e.prototype.getAllKeys = function (t) {
        var e,
            i = this.db.transaction(["LokiAKV"], "readonly"),
            r = i.objectStore("LokiAKV"),
            n = r.openCursor();
        n.onsuccess = function (t, e) {
          return function (i) {
            var r = i.target.result;

            if (r) {
              var n = r.value;
              t.push(n), r.continue();
            } else "function" == typeof e ? e(t) : console.log(t);
          };
        }([], t), n.onerror = (e = t, function (t) {
          "function" == typeof e && e(null);
        });
      }, t;
    }();
  }),
      s = n(function (t, e) {
    t.exports = function () {
      var t = Object.prototype.hasOwnProperty,
          e = {
        copyProperties: function (t, e) {
          var i;

          for (i in t) e[i] = t[i];
        },
        resolveTransformObject: function (t, i, r) {
          var n, o;
          if ("number" != typeof r && (r = 0), ++r >= 10) return t;

          for (n in t) "string" == typeof t[n] && 0 === t[n].indexOf("[%lktxp]") ? (o = t[n].substring(8), i.hasOwnProperty(o) && (t[n] = i[o])) : "object" == typeof t[n] && (t[n] = e.resolveTransformObject(t[n], i, r));

          return t;
        },
        resolveTransformParams: function (t, i) {
          var r,
              n,
              o = [];
          if (void 0 === i) return t;

          for (r = 0; r < t.length; r++) n = f(t[r], "shallow-recurse-objects"), o.push(e.resolveTransformObject(n, i));

          return o;
        },
        getIn: function (t, e, i) {
          if (null != t) {
            if (!i) return t[e];
            if ("string" == typeof e && (e = e.split(".")), !Array.isArray(e)) throw new Error("path must be a string or array. Found " + typeof e);

            for (var r = 0, n = e.length; null != t && r < n;) t = t[e[r++]];

            return r && r == n ? t : void 0;
          }
        }
      },
          i = {
        aeq: n,
        lt: s,
        gt: a
      };

      function n(t, e) {
        var i, r, n, o;
        if (t === e) return !0;

        if (!t || !e || !0 === t || !0 === e || t != t || e != e) {
          switch (t) {
            case void 0:
            case null:
              n = 1;
              break;

            case !1:
              n = 3;
              break;

            case !0:
              n = 4;
              break;

            case "":
              n = 5;
              break;

            default:
              n = t == t ? 9 : 0;
          }

          switch (e) {
            case void 0:
            case null:
              o = 1;
              break;

            case !1:
              o = 3;
              break;

            case !0:
              o = 4;
              break;

            case "":
              o = 5;
              break;

            default:
              o = e == e ? 9 : 0;
          }

          if (9 !== n || 9 !== o) return n === o;
        }

        return i = Number(t), r = Number(e), i == i || r == r ? i === r : (i = t.toString(), r = e.toString(), i == r);
      }

      function s(t, e, i) {
        var r, n, o, s;

        if (!t || !e || !0 === t || !0 === e || t != t || e != e) {
          switch (t) {
            case void 0:
            case null:
              o = 1;
              break;

            case !1:
              o = 3;
              break;

            case !0:
              o = 4;
              break;

            case "":
              o = 5;
              break;

            default:
              o = t == t ? 9 : 0;
          }

          switch (e) {
            case void 0:
            case null:
              s = 1;
              break;

            case !1:
              s = 3;
              break;

            case !0:
              s = 4;
              break;

            case "":
              s = 5;
              break;

            default:
              s = e == e ? 9 : 0;
          }

          if (9 !== o || 9 !== s) return o === s ? i : o < s;
        }

        return r = Number(t), n = Number(e), r == r && n == n ? r < n || !(r > n) && i : r == r && n != n || (n != n || r == r) && (t < e || !(t > e) && (t == e ? i : (r = t.toString(), n = e.toString(), r < n || r == n && i)));
      }

      function a(t, e, i) {
        var r, n, o, s;

        if (!t || !e || !0 === t || !0 === e || t != t || e != e) {
          switch (t) {
            case void 0:
            case null:
              o = 1;
              break;

            case !1:
              o = 3;
              break;

            case !0:
              o = 4;
              break;

            case "":
              o = 5;
              break;

            default:
              o = t == t ? 9 : 0;
          }

          switch (e) {
            case void 0:
            case null:
              s = 1;
              break;

            case !1:
              s = 3;
              break;

            case !0:
              s = 4;
              break;

            case "":
              s = 5;
              break;

            default:
              s = e == e ? 9 : 0;
          }

          if (9 !== o || 9 !== s) return o === s ? i : o > s;
        }

        return r = Number(t), n = Number(e), r == r && n == n ? r > n || !(r < n) && i : (r != r || n == n) && (n == n && r != r || t > e || !(t < e) && (t == e ? i : (r = t.toString(), n = e.toString(), r > n || r == n && i)));
      }

      function l(t, e, r) {
        return i.aeq(t, e) ? 0 : i.lt(t, e, !1) ? r ? 1 : -1 : i.gt(t, e, !1) ? r ? -1 : 1 : 0;
      }

      function h(t, e, i, r, n) {
        var o,
            s = n || 0,
            a = e[s],
            l = !1;
        if ("object" == typeof t && a in t && (o = t[a]), s + 1 >= e.length) l = i(o, r);else if (Array.isArray(o)) for (var c = 0, u = o.length; c < u && !0 !== (l = h(o[c], e, i, r, s + 1)); c += 1);else l = h(o, e, i, r, s + 1);
        return l;
      }

      function c(e) {
        return "string" == typeof e || Array.isArray(e) ? function (t) {
          return -1 !== e.indexOf(t);
        } : "object" == typeof e && null !== e ? function (i) {
          return t.call(e, i);
        } : null;
      }

      function u(e, i) {
        for (var r in i) if (t.call(i, r)) return d[r](e, i[r]);

        return !1;
      }

      var d = {
        $eq: function (t, e) {
          return t === e;
        },
        $aeq: function (t, e) {
          return t == e;
        },
        $ne: function (t, e) {
          return e != e ? t == t : t !== e;
        },
        $dteq: function (t, e) {
          return i.aeq(t, e);
        },
        $gt: function (t, e) {
          return i.gt(t, e, !1);
        },
        $gte: function (t, e) {
          return i.gt(t, e, !0);
        },
        $lt: function (t, e) {
          return i.lt(t, e, !1);
        },
        $lte: function (t, e) {
          return i.lt(t, e, !0);
        },
        $jgt: function (t, e) {
          return t > e;
        },
        $jgte: function (t, e) {
          return t >= e;
        },
        $jlt: function (t, e) {
          return t < e;
        },
        $jlte: function (t, e) {
          return t <= e;
        },
        $between: function (t, e) {
          return null != t && i.gt(t, e[0], !0) && i.lt(t, e[1], !0);
        },
        $jbetween: function (t, e) {
          return null != t && t >= e[0] && t <= e[1];
        },
        $in: function (t, e) {
          return -1 !== e.indexOf(t);
        },
        $nin: function (t, e) {
          return -1 === e.indexOf(t);
        },
        $keyin: function (t, e) {
          return t in e;
        },
        $nkeyin: function (t, e) {
          return !(t in e);
        },
        $definedin: function (t, e) {
          return void 0 !== e[t];
        },
        $undefinedin: function (t, e) {
          return void 0 === e[t];
        },
        $regex: function (t, e) {
          return e.test(t);
        },
        $containsString: function (t, e) {
          return "string" == typeof t && -1 !== t.indexOf(e);
        },
        $containsNone: function (t, e) {
          return !d.$containsAny(t, e);
        },
        $containsAny: function (t, e) {
          var i = c(t);
          return null !== i && (Array.isArray(e) ? e.some(i) : i(e));
        },
        $contains: function (t, e) {
          var i = c(t);
          return null !== i && (Array.isArray(e) ? e.every(i) : i(e));
        },
        $elemMatch: function (t, e) {
          return !!Array.isArray(t) && t.some(function (t) {
            return Object.keys(e).every(function (i) {
              var r = e[i];
              return "object" == typeof r && r || (r = {
                $eq: r
              }), -1 !== i.indexOf(".") ? h(t, i.split("."), u, e[i]) : u(t[i], r);
            });
          });
        },
        $type: function (t, e) {
          var i = typeof t;
          return "object" === i && (Array.isArray(t) ? i = "array" : t instanceof Date && (i = "date")), "object" != typeof e ? i === e : u(i, e);
        },
        $finite: function (t, e) {
          return e === isFinite(t);
        },
        $size: function (t, e) {
          return !!Array.isArray(t) && ("object" != typeof e ? t.length === e : u(t.length, e));
        },
        $len: function (t, e) {
          return "string" == typeof t && ("object" != typeof e ? t.length === e : u(t.length, e));
        },
        $where: function (t, e) {
          return !0 === e(t);
        },
        $not: function (t, e) {
          return !u(t, e);
        },
        $and: function (t, e) {
          for (var i = 0, r = e.length; i < r; i += 1) if (!u(t, e[i])) return !1;

          return !0;
        },
        $or: function (t, e) {
          for (var i = 0, r = e.length; i < r; i += 1) if (u(t, e[i])) return !0;

          return !1;
        },
        $exists: function (t, e) {
          return e ? void 0 !== t : void 0 === t;
        }
      },
          p = {
        $eq: d.$eq,
        $aeq: !0,
        $dteq: !0,
        $gt: !0,
        $gte: !0,
        $lt: !0,
        $lte: !0,
        $in: !0,
        $between: !0
      };

      function f(t, e) {
        if (null == t) return null;
        var i,
            r = e || "parse-stringify";

        switch (r) {
          case "parse-stringify":
            i = JSON.parse(JSON.stringify(t));
            break;

          case "jquery-extend-deep":
            i = jQuery.extend(!0, {}, t);
            break;

          case "shallow":
            i = Object.create(t.constructor.prototype), Object.keys(t).map(function (e) {
              i[e] = t[e];
            });
            break;

          case "shallow-assign":
            i = Object.create(t.constructor.prototype), Object.assign(i, t);
            break;

          case "shallow-recurse-objects":
            i = f(t, "shallow");
            var n = Object.keys(t);
            n.forEach(function (e) {
              "object" == typeof t[e] && "Object" === t[e].constructor.name ? i[e] = f(t[e], "shallow-recurse-objects") : Array.isArray(t[e]) && (i[e] = function (t, e) {
                if ("parse-stringify" == e) return f(t, e);

                for (var i = [], r = 0, n = t.length; r < n; r++) i[r] = f(t[r], e);

                return i;
              }(t[e], "shallow-recurse-objects"));
            });
        }

        return i;
      }

      function y() {
        try {
          return window && void 0 !== window.localStorage && null !== window.localStorage;
        } catch (t) {
          return !1;
        }
      }

      function v() {}

      function g(t, e) {
        this.filename = t || "loki.db", this.collections = [], this.databaseVersion = 1.5, this.engineVersion = 1.5, this.autosave = !1, this.autosaveInterval = 5e3, this.autosaveHandle = null, this.throttledSaves = !0, this.options = {}, this.persistenceMethod = null, this.persistenceAdapter = null, this.throttledSavePending = !1, this.throttledCallbacks = [], this.verbose = !(!e || !e.hasOwnProperty("verbose")) && e.verbose, this.events = {
          init: [],
          loaded: [],
          flushChanges: [],
          close: [],
          changes: [],
          warning: []
        }, e && e.hasOwnProperty("env") ? this.ENV = e.env : this.ENV = void 0 !== r && (r.android || r.NSObject) ? "NATIVESCRIPT" : "undefined" == typeof window ? "NODEJS" : void 0 !== r && r.window && "undefined" != typeof process ? "NODEJS" : "undefined" != typeof document ? -1 === document.URL.indexOf("http://") && -1 === document.URL.indexOf("https://") ? "CORDOVA" : "BROWSER" : "CORDOVA", "undefined" === this.ENV && (this.ENV = "NODEJS"), this.configureOptions(e, !0), this.on("init", this.clearChanges);
      }

      function m(t) {
        this.hashStore = {}, this.options = t || {}, this.options.hasOwnProperty("asyncResponses") || (this.options.asyncResponses = !1), this.options.hasOwnProperty("asyncTimeout") || (this.options.asyncTimeout = 50);
      }

      function b(t, e) {
        if (this.mode = "reference", this.adapter = null, this.options = e || {}, this.dbref = null, this.dbname = "", this.pageIterator = {}, !t) throw new Error("LokiPartitioningAdapter requires a (non-reference mode) adapter on construction");
        if ("reference" === t.mode) throw new Error("LokiPartitioningAdapter cannot be instantiated with a reference mode adapter");
        this.adapter = t, this.options.hasOwnProperty("paging") || (this.options.paging = !1), this.options.hasOwnProperty("pageSize") || (this.options.pageSize = 26214400), this.options.hasOwnProperty("delimiter") || (this.options.delimiter = "$<\n");
      }

      function w() {
        try {
          this.fs = require("fs");
        } catch (t) {
          this.fs = null;
        }
      }

      function I() {}

      function O(t, e) {
        return e = e || {}, this.collection = t, this.filteredrows = [], this.filterInitialized = !1, this;
      }

      function x(t, e, i) {
        this.collection = t, this.name = e, this.rebuildPending = !1, this.options = i || {}, this.options.hasOwnProperty("persistent") || (this.options.persistent = !1), this.options.hasOwnProperty("sortPriority") || (this.options.sortPriority = "passive"), this.options.hasOwnProperty("minRebuildInterval") || (this.options.minRebuildInterval = 1), this.resultset = new O(t), this.resultdata = [], this.resultsdirty = !1, this.cachedresultset = null, this.filterPipeline = [], this.sortFunction = null, this.sortCriteria = null, this.sortCriteriaSimple = null, this.sortDirty = !1, this.events = {
          rebuild: []
        };
      }

      function k(e, i) {
        this.name = e, this.data = [], this.idIndex = [], this.binaryIndices = {}, this.constraints = {
          unique: {},
          exact: {}
        }, this.uniqueNames = [], this.transforms = {}, this.objType = e, this.dirty = !0, this.cachedIndex = null, this.cachedBinaryIndex = null, this.cachedData = null;
        var r = this;
        (i = i || {}).hasOwnProperty("unique") && (Array.isArray(i.unique) || (i.unique = [i.unique]), i.unique.forEach(function (t) {
          r.uniqueNames.push(t), r.constraints.unique[t] = new N(t);
        })), i.hasOwnProperty("exact") && i.exact.forEach(function (t) {
          r.constraints.exact[t] = new M(t);
        }), this.adaptiveBinaryIndices = !i.hasOwnProperty("adaptiveBinaryIndices") || i.adaptiveBinaryIndices, this.transactional = !!i.hasOwnProperty("transactional") && i.transactional, this.cloneObjects = !!i.hasOwnProperty("clone") && i.clone, this.cloneMethod = i.hasOwnProperty("cloneMethod") ? i.cloneMethod : "parse-stringify", this.asyncListeners = !!i.hasOwnProperty("asyncListeners") && i.asyncListeners, this.disableMeta = !!i.hasOwnProperty("disableMeta") && i.disableMeta, this.disableChangesApi = !i.hasOwnProperty("disableChangesApi") || i.disableChangesApi, this.disableDeltaChangesApi = !i.hasOwnProperty("disableDeltaChangesApi") || i.disableDeltaChangesApi, this.disableChangesApi && (this.disableDeltaChangesApi = !0), this.autoupdate = !!i.hasOwnProperty("autoupdate") && i.autoupdate, this.serializableIndices = !i.hasOwnProperty("serializableIndices") || i.serializableIndices, this.ttl = {
          age: null,
          ttlInterval: null,
          daemon: null
        }, this.setTTL(i.ttl || -1, i.ttlInterval), this.maxId = 0, this.DynamicViews = [], this.events = {
          insert: [],
          update: [],
          "pre-insert": [],
          "pre-update": [],
          close: [],
          flushbuffer: [],
          error: [],
          delete: [],
          warning: []
        }, this.changes = [], this.ensureId();
        var n = [];
        if (i && i.indices) if ("[object Array]" === Object.prototype.toString.call(i.indices)) n = i.indices;else {
          if ("string" != typeof i.indices) throw new TypeError("Indices needs to be a string or an array of strings");
          n = [i.indices];
        }

        for (var o = 0; o < n.length; o++) this.ensureIndex(n[o]);

        function s(t, e) {
          var i = null !== e && "object" == typeof e ? Object.keys(e) : null;

          if (i && i.length && ["string", "boolean", "number"].indexOf(typeof e) < 0) {
            for (var n = {}, o = 0; o < i.length; o++) {
              var a = i[o];
              if (e.hasOwnProperty(a)) if (!t.hasOwnProperty(a) || r.uniqueNames.indexOf(a) >= 0 || "$loki" == a || "meta" == a) n[a] = e[a];else {
                var l = s(t[a], e[a]);
                void 0 !== l && l != {} && (n[a] = l);
              }
            }

            return 0 === Object.keys(n).length ? void 0 : n;
          }

          return t === e ? void 0 : e;
        }

        function a() {
          r.changes = [];
        }

        this.observerCallback = function (e) {
          var i = "function" == typeof Set ? new Set() : [];
          i.add || (i.add = function (t) {
            return -1 === this.indexOf(t) && this.push(t), this;
          }), e.forEach(function (t) {
            i.add(t.object);
          }), i.forEach(function (e) {
            if (!t.call(e, "$loki")) return r.removeAutoUpdateObserver(e);

            try {
              r.update(e);
            } catch (t) {}
          });
        }, this.getChangeDelta = function (t, e) {
          return e ? s(e, t) : JSON.parse(JSON.stringify(t));
        }, this.getObjectDelta = s, this.getChanges = function () {
          return r.changes;
        }, this.flushChanges = a, this.setChangesApi = function (t) {
          r.disableChangesApi = !t, t || (r.disableDeltaChangesApi = !1);
        }, this.on("delete", function (t) {
          r.disableChangesApi || r.createChange(r.name, "R", t);
        }), this.on("warning", function (t) {
          r.lokiConsoleWrapper.warn(t);
        }), a();
      }

      function D(t) {
        return -1 !== t.indexOf(".");
      }

      function S(t) {
        return parseFloat(t, 10);
      }

      function P(t, e) {
        return t + e;
      }

      function A(t, e) {
        return t - e;
      }

      function C(t) {
        return t.reduce(P, 0) / t.length;
      }

      function $(t, e, i) {
        if (!1 === i) return t[e];

        for (var r = e.split("."), n = t; r.length > 0;) n = n[r.shift()];

        return n;
      }

      function q(t, e, i) {
        for (var r, n, o = 0, s = t.length; o < s;) {
          if (n = o + s >> 1, 0 === (r = i.apply(null, [e, t[n]]))) return {
            found: !0,
            index: n
          };
          r < 0 ? s = n : o = n + 1;
        }

        return {
          found: !1,
          index: s
        };
      }

      function j(t) {
        return function (e, i) {
          return q(e, i, t);
        };
      }

      function E() {}

      function N(t) {
        this.field = t, this.keyMap = {}, this.lokiMap = {};
      }

      function M(t) {
        this.index = {}, this.field = t;
      }

      return v.prototype.events = {}, v.prototype.asyncListeners = !1, v.prototype.on = function (t, e) {
        var i,
            r = this;
        return Array.isArray(t) ? (t.forEach(function (t) {
          r.on(t, e);
        }), e) : ((i = this.events[t]) || (i = this.events[t] = []), i.push(e), e);
      }, v.prototype.emit = function (t) {
        var e = this,
            i = Array.prototype.slice.call(arguments, 1);
        if (!t || !this.events[t]) throw new Error("No event " + t + " defined");
        this.events[t].forEach(function (t) {
          e.asyncListeners ? setTimeout(function () {
            t.apply(e, i);
          }, 1) : t.apply(e, i);
        });
      }, v.prototype.addListener = v.prototype.on, v.prototype.removeListener = function (t, e) {
        var i = this;
        if (Array.isArray(t)) t.forEach(function (t) {
          i.removeListener(t, e);
        });else if (this.events[t]) {
          var r = this.events[t];
          r.splice(r.indexOf(e), 1);
        }
      }, g.prototype = new v(), g.prototype.constructor = g, g.prototype.getIndexedAdapter = function () {
        var t;
        return "function" == typeof require && (t = o), t;
      }, g.prototype.configureOptions = function (t, e) {
        var i = {
          fs: w,
          localStorage: I,
          memory: m
        };

        if (this.options = {}, this.persistenceMethod = null, this.persistenceAdapter = null, void 0 !== t) {
          if (this.options = t, this.options.hasOwnProperty("persistenceMethod") && "function" == typeof i[t.persistenceMethod] && (this.persistenceMethod = t.persistenceMethod, this.persistenceAdapter = new i[t.persistenceMethod]()), this.options.hasOwnProperty("adapter") && (this.persistenceMethod = "adapter", this.persistenceAdapter = t.adapter, this.options.adapter = null), t.autoload && e) {
            var r = this;
            setTimeout(function () {
              r.loadDatabase(t, t.autoloadCallback);
            }, 1);
          }

          this.options.hasOwnProperty("autosaveInterval") && (this.autosaveDisable(), this.autosaveInterval = parseInt(this.options.autosaveInterval, 10)), this.options.hasOwnProperty("autosave") && this.options.autosave && (this.autosaveDisable(), this.autosave = !0, this.options.hasOwnProperty("autosaveCallback") ? this.autosaveEnable(t, t.autosaveCallback) : this.autosaveEnable()), this.options.hasOwnProperty("throttledSaves") && (this.throttledSaves = this.options.throttledSaves);
        }

        this.options.hasOwnProperty("serializationMethod") || (this.options.serializationMethod = "normal"), this.options.hasOwnProperty("destructureDelimiter") || (this.options.destructureDelimiter = "$<\n"), null === this.persistenceAdapter && (this.persistenceMethod = {
          NODEJS: "fs",
          BROWSER: "localStorage",
          CORDOVA: "localStorage",
          MEMORY: "memory"
        }[this.ENV], this.persistenceMethod && (this.persistenceAdapter = new i[this.persistenceMethod]()));
      }, g.prototype.copy = function (t) {
        var e,
            i,
            r = new g(this.filename, {
          env: "NA"
        });
        if (t = t || {}, r.loadJSONObject(this, {
          retainDirtyFlags: !0
        }), t.hasOwnProperty("removeNonSerializable") && !0 === t.removeNonSerializable) for (r.autosaveHandle = null, r.persistenceAdapter = null, e = r.collections.length, i = 0; i < e; i++) r.collections[i].constraints = null, r.collections[i].ttl = null;
        return r;
      }, g.prototype.addCollection = function (t, e) {
        var i,
            r = this.collections.length;

        if (e && !0 === e.disableMeta) {
          if (!1 === e.disableChangesApi) throw new Error("disableMeta option cannot be passed as true when disableChangesApi is passed as false");
          if (!1 === e.disableDeltaChangesApi) throw new Error("disableMeta option cannot be passed as true when disableDeltaChangesApi is passed as false");
          if ("number" == typeof e.ttl && e.ttl > 0) throw new Error("disableMeta option cannot be passed as true when ttl is enabled");
        }

        for (i = 0; i < r; i += 1) if (this.collections[i].name === t) return this.collections[i];

        var n = new k(t, e);
        return this.collections.push(n), this.verbose && (n.lokiConsoleWrapper = console), n;
      }, g.prototype.loadCollection = function (t) {
        if (!t.name) throw new Error("Collection must have a name property to be loaded");
        this.collections.push(t);
      }, g.prototype.getCollection = function (t) {
        var e,
            i = this.collections.length;

        for (e = 0; e < i; e += 1) if (this.collections[e].name === t) return this.collections[e];

        return this.emit("warning", "collection " + t + " not found"), null;
      }, g.prototype.renameCollection = function (t, e) {
        var i = this.getCollection(t);
        return i && (i.name = e), i;
      }, g.prototype.listCollections = function () {
        for (var t = this.collections.length, e = []; t--;) e.push({
          name: this.collections[t].name,
          type: this.collections[t].objType,
          count: this.collections[t].data.length
        });

        return e;
      }, g.prototype.removeCollection = function (t) {
        var e,
            i = this.collections.length;

        for (e = 0; e < i; e += 1) if (this.collections[e].name === t) {
          var r = new k(t, {}),
              n = this.collections[e];

          for (var o in n) n.hasOwnProperty(o) && r.hasOwnProperty(o) && (n[o] = r[o]);

          return void this.collections.splice(e, 1);
        }
      }, g.prototype.getName = function () {
        return this.name;
      }, g.prototype.serializeReplacer = function (t, e) {
        switch (t) {
          case "autosaveHandle":
          case "persistenceAdapter":
          case "constraints":
          case "ttl":
            return null;

          case "throttledSavePending":
          case "throttledCallbacks":
            return;

          case "lokiConsoleWrapper":
            return null;

          default:
            return e;
        }
      }, g.prototype.serialize = function (t) {
        switch ((t = t || {}).hasOwnProperty("serializationMethod") || (t.serializationMethod = this.options.serializationMethod), t.serializationMethod) {
          case "normal":
            return JSON.stringify(this, this.serializeReplacer);

          case "pretty":
            return JSON.stringify(this, this.serializeReplacer, 2);

          case "destructured":
            return this.serializeDestructured();

          default:
            return JSON.stringify(this, this.serializeReplacer);
        }
      }, g.prototype.toJson = g.prototype.serialize, g.prototype.serializeDestructured = function (t) {
        var e,
            i,
            r,
            n,
            o,
            s = [];
        if ((t = t || {}).hasOwnProperty("partitioned") || (t.partitioned = !1), t.hasOwnProperty("delimited") || (t.delimited = !0), t.hasOwnProperty("delimiter") || (t.delimiter = this.options.destructureDelimiter), !0 === t.partitioned && t.hasOwnProperty("partition") && t.partition >= 0) return this.serializeCollection({
          delimited: t.delimited,
          delimiter: t.delimiter,
          collectionIndex: t.partition
        });

        for ((o = new g(this.filename)).loadJSONObject(this), e = 0; e < o.collections.length; e++) o.collections[e].data = [];

        if (!0 === t.partitioned && -1 === t.partition) return o.serialize({
          serializationMethod: "normal"
        });

        for (s.push(o.serialize({
          serializationMethod: "normal"
        })), o = null, e = 0; e < this.collections.length; e++) if (r = this.serializeCollection({
          delimited: t.delimited,
          delimiter: t.delimiter,
          collectionIndex: e
        }), !1 === t.partitioned && !1 === t.delimited) {
          if (!Array.isArray(r)) throw new Error("a nondelimited, non partitioned collection serialization did not return an expected array");

          for (n = r.length, i = 0; i < n; i++) s.push(r[i]), r[i] = null;

          s.push("");
        } else s.push(r);

        return t.partitioned ? (t.delimited, s) : t.delimited ? (s.push(""), s.join(t.delimiter)) : (s.push(""), s);
      }, g.prototype.serializeCollection = function (t) {
        var e,
            i,
            r = [];
        if ((t = t || {}).hasOwnProperty("delimited") || (t.delimited = !0), !t.hasOwnProperty("collectionIndex")) throw new Error("serializeCollection called without 'collectionIndex' option");

        for (e = this.collections[t.collectionIndex].data.length, r = [], i = 0; i < e; i++) r.push(JSON.stringify(this.collections[t.collectionIndex].data[i]));

        return t.delimited ? (r.push(""), r.join(t.delimiter)) : r;
      }, g.prototype.deserializeDestructured = function (t, e) {
        var i,
            r,
            n,
            o = [],
            s = 0,
            a = 1,
            l = !1;

        if ((e = e || {}).hasOwnProperty("partitioned") || (e.partitioned = !1), e.hasOwnProperty("delimited") || (e.delimited = !0), e.hasOwnProperty("delimiter") || (e.delimiter = this.options.destructureDelimiter), e.partitioned) {
          if (e.hasOwnProperty("partition")) return -1 === e.partition ? i = JSON.parse(t[0]) : this.deserializeCollection(t[e.partition + 1], e);

          for (i = JSON.parse(t[0]), r = i.collections.length, s = 0; s < r; s++) i.collections[s].data = this.deserializeCollection(t[s + 1], e);

          return i;
        }

        if (e.delimited) {
          if (o = t.split(e.delimiter), t = null, 0 === o.length) return null;
        } else o = t;

        for (i = JSON.parse(o[0]), r = i.collections.length, o[0] = null; !l;) o[a], "" === o[a] ? ++s > r && (l = !0) : (n = JSON.parse(o[a]), i.collections[s].data.push(n)), o[a++] = null;

        return i;
      }, g.prototype.deserializeCollection = function (t, e) {
        var i,
            r,
            n = [];

        for ((e = e || {}).hasOwnProperty("partitioned") || (e.partitioned = !1), e.hasOwnProperty("delimited") || (e.delimited = !0), e.hasOwnProperty("delimiter") || (e.delimiter = this.options.destructureDelimiter), e.delimited ? (n = t.split(e.delimiter)).pop() : n = t, r = n.length, i = 0; i < r; i++) n[i] = JSON.parse(n[i]);

        return n;
      }, g.prototype.loadJSON = function (t, e) {
        var i;
        if (0 === t.length) i = {};else switch (this.options.serializationMethod) {
          case "normal":
          case "pretty":
            i = JSON.parse(t);
            break;

          case "destructured":
            i = this.deserializeDestructured(t);
            break;

          default:
            i = JSON.parse(t);
        }
        this.loadJSONObject(i, e);
      }, g.prototype.loadJSONObject = function (t, i) {
        var r,
            n,
            o,
            s,
            a,
            l,
            h = 0,
            c = t.collections ? t.collections.length : 0;

        function u(t) {
          var r,
              n = i[t.name];
          return n.proto ? (r = n.inflate || e.copyProperties, function (t) {
            var e = new n.proto();
            return r(t, e), e;
          }) : n.inflate;
        }

        for (this.name = t.name, t.hasOwnProperty("throttledSaves") && i && !i.hasOwnProperty("throttledSaves") && (this.throttledSaves = t.throttledSaves), this.collections = []; h < c; h += 1) {
          if (r = t.collections[h], (n = this.addCollection(r.name, {
            disableChangesApi: r.disableChangesApi,
            disableDeltaChangesApi: r.disableDeltaChangesApi,
            disableMeta: r.disableMeta
          })).adaptiveBinaryIndices = !!r.hasOwnProperty("adaptiveBinaryIndices") && !0 === r.adaptiveBinaryIndices, n.transactional = r.transactional, n.asyncListeners = r.asyncListeners, n.cloneObjects = r.cloneObjects, n.cloneMethod = r.cloneMethod || "parse-stringify", n.autoupdate = r.autoupdate, n.changes = r.changes, i && !0 === i.retainDirtyFlags ? n.dirty = r.dirty : n.dirty = !1, o = r.data.length, s = 0, i && i.hasOwnProperty(r.name)) for (a = u(r); s < o; s++) l = a(r.data[s]), n.data[s] = l, n.addAutoUpdateObserver(l);else for (; s < o; s++) n.data[s] = r.data[s], n.addAutoUpdateObserver(n.data[s]);
          if (n.maxId = void 0 === r.maxId ? 0 : r.maxId, n.idIndex = r.idIndex, void 0 !== r.binaryIndices && (n.binaryIndices = r.binaryIndices), void 0 !== r.transforms && (n.transforms = r.transforms), n.ensureId(), n.uniqueNames = [], r.hasOwnProperty("uniqueNames")) for (n.uniqueNames = r.uniqueNames, s = 0; s < n.uniqueNames.length; s++) n.ensureUniqueIndex(n.uniqueNames[s]);

          if (void 0 !== r.DynamicViews) {
            for (var d = 0; d < r.DynamicViews.length; d++) {
              var p = r.DynamicViews[d],
                  f = n.addDynamicView(p.name, p.options);
              f.resultdata = p.resultdata, f.resultsdirty = p.resultsdirty, f.filterPipeline = p.filterPipeline, f.sortCriteria = p.sortCriteria, f.sortFunction = null, f.sortDirty = p.sortDirty, f.resultset.filteredrows = p.resultset.filteredrows, f.resultset.filterInitialized = p.resultset.filterInitialized, f.rematerialize({
                removeWhereFilters: !0
              });
            }

            t.databaseVersion < 1.5 && (n.ensureAllIndexes(!0), n.dirty = !0);
          }
        }
      }, g.prototype.close = function (t) {
        this.autosave && (this.autosaveDisable(), this.autosaveDirty() && (this.saveDatabase(t), t = void 0)), t && this.on("close", t), this.emit("close");
      }, g.prototype.generateChangesNotification = function (t) {
        function e(t) {
          return t.name;
        }

        var i = [],
            r = t || this.collections.map(e);
        return this.collections.forEach(function (t) {
          -1 !== r.indexOf(e(t)) && (i = i.concat(t.getChanges()));
        }), i;
      }, g.prototype.serializeChanges = function (t) {
        return JSON.stringify(this.generateChangesNotification(t));
      }, g.prototype.clearChanges = function () {
        this.collections.forEach(function (t) {
          t.flushChanges && t.flushChanges();
        });
      }, m.prototype.loadDatabase = function (t, e) {
        var i = this;
        this.options.asyncResponses ? setTimeout(function () {
          i.hashStore.hasOwnProperty(t) ? e(i.hashStore[t].value) : e(null);
        }, this.options.asyncTimeout) : this.hashStore.hasOwnProperty(t) ? e(this.hashStore[t].value) : e(null);
      }, m.prototype.saveDatabase = function (t, e, i) {
        var r,
            n = this;
        this.options.asyncResponses ? setTimeout(function () {
          r = n.hashStore.hasOwnProperty(t) ? n.hashStore[t].savecount : 0, n.hashStore[t] = {
            savecount: r + 1,
            lastsave: new Date(),
            value: e
          }, i();
        }, this.options.asyncTimeout) : (r = this.hashStore.hasOwnProperty(t) ? this.hashStore[t].savecount : 0, this.hashStore[t] = {
          savecount: r + 1,
          lastsave: new Date(),
          value: e
        }, i());
      }, m.prototype.deleteDatabase = function (t, e) {
        this.hashStore.hasOwnProperty(t) && delete this.hashStore[t], "function" == typeof e && e();
      }, b.prototype.loadDatabase = function (t, e) {
        var i = this;
        this.dbname = t, this.dbref = new g(t), this.adapter.loadDatabase(t, function (t) {
          if (t) {
            "string" != typeof t && e(new Error("LokiPartitioningAdapter received an unexpected response from inner adapter loadDatabase()"));
            var r = JSON.parse(t);
            i.dbref.loadJSONObject(r), r = null, i.dbref.collections.length, 0 !== i.dbref.collections.length ? (i.pageIterator = {
              collection: 0,
              pageIndex: 0
            }, i.loadNextPartition(0, function () {
              e(i.dbref);
            })) : e(i.dbref);
          } else e(t);
        });
      }, b.prototype.loadNextPartition = function (t, e) {
        var i = this.dbname + "." + t,
            r = this;
        if (!0 === this.options.paging) return this.pageIterator.pageIndex = 0, void this.loadNextPage(e);
        this.adapter.loadDatabase(i, function (i) {
          var n = r.dbref.deserializeCollection(i, {
            delimited: !0,
            collectionIndex: t
          });
          r.dbref.collections[t].data = n, ++t < r.dbref.collections.length ? r.loadNextPartition(t, e) : e();
        });
      }, b.prototype.loadNextPage = function (t) {
        var e = this.dbname + "." + this.pageIterator.collection + "." + this.pageIterator.pageIndex,
            i = this;
        this.adapter.loadDatabase(e, function (e) {
          var r = e.split(i.options.delimiter);
          e = "";
          var n,
              o = r.length,
              s = "" === r[o - 1];

          for (s && (r.pop(), o = r.length, "" === r[o - 1] && 1 === o && (r.pop(), o = r.length)), n = 0; n < o; n++) i.dbref.collections[i.pageIterator.collection].data.push(JSON.parse(r[n])), r[n] = null;

          r = [], s ? ++i.pageIterator.collection < i.dbref.collections.length ? i.loadNextPartition(i.pageIterator.collection, t) : t() : (i.pageIterator.pageIndex++, i.loadNextPage(t));
        });
      }, b.prototype.exportDatabase = function (t, e, i) {
        var r,
            n = e.collections.length;

        for (this.dbref = e, this.dbname = t, this.dirtyPartitions = [-1], r = 0; r < n; r++) e.collections[r].dirty && this.dirtyPartitions.push(r);

        this.saveNextPartition(function (t) {
          i(t);
        });
      }, b.prototype.saveNextPartition = function (t) {
        var e = this,
            i = this.dirtyPartitions.shift(),
            r = this.dbname + (-1 === i ? "" : "." + i);
        if (this.options.paging && -1 !== i) return this.pageIterator = {
          collection: i,
          docIndex: 0,
          pageIndex: 0
        }, void this.saveNextPage(function (i) {
          0 === e.dirtyPartitions.length ? t(i) : e.saveNextPartition(t);
        });
        var n = this.dbref.serializeDestructured({
          partitioned: !0,
          delimited: !0,
          partition: i
        });
        this.adapter.saveDatabase(r, n, function (i) {
          i ? t(i) : 0 === e.dirtyPartitions.length ? t(null) : e.saveNextPartition(t);
        });
      }, b.prototype.saveNextPage = function (t) {
        var e = this,
            i = this.dbref.collections[this.pageIterator.collection],
            r = this.dbname + "." + this.pageIterator.collection + "." + this.pageIterator.pageIndex,
            n = 0,
            o = i.data.length,
            s = this.options.delimiter.length,
            a = "",
            l = "",
            h = !1,
            c = !1,
            u = function (i) {
          l = "", i && t(i), h ? t(null) : (e.pageIterator.pageIndex++, e.saveNextPage(t));
        };

        for (0 === i.data.length && (h = !0);;) if (h || (a = JSON.stringify(i.data[this.pageIterator.docIndex]), l += a, n += a.length, ++this.pageIterator.docIndex >= o && (h = !0)), n >= this.options.pageSize && (c = !0), c && !h || (l += this.options.delimiter, n += s), h || c) return void this.adapter.saveDatabase(r, l, u);
      }, w.prototype.loadDatabase = function (t, e) {
        var i = this;
        this.fs.stat(t, function (r, n) {
          !r && n.isFile() ? i.fs.readFile(t, {
            encoding: "utf8"
          }, function (t, i) {
            e(t ? new Error(t) : i);
          }) : e(null);
        });
      }, w.prototype.saveDatabase = function (t, e, i) {
        var r = this,
            n = t + "~";
        this.fs.writeFile(n, e, function (e) {
          e ? i(new Error(e)) : r.fs.rename(n, t, i);
        });
      }, w.prototype.deleteDatabase = function (t, e) {
        this.fs.unlink(t, function (t) {
          t ? e(new Error(t)) : e();
        });
      }, I.prototype.loadDatabase = function (t, e) {
        y() ? e(localStorage.getItem(t)) : e(new Error("localStorage is not available"));
      }, I.prototype.saveDatabase = function (t, e, i) {
        y() ? (localStorage.setItem(t, e), i(null)) : i(new Error("localStorage is not available"));
      }, I.prototype.deleteDatabase = function (t, e) {
        y() ? (localStorage.removeItem(t), e(null)) : e(new Error("localStorage is not available"));
      }, g.prototype.throttledSaveDrain = function (t, e) {
        var i = this,
            r = new Date().getTime();

        if (this.throttledSaves || t(!0), (e = e || {}).hasOwnProperty("recursiveWait") || (e.recursiveWait = !0), e.hasOwnProperty("recursiveWaitLimit") || (e.recursiveWaitLimit = !1), e.hasOwnProperty("recursiveWaitLimitDuration") || (e.recursiveWaitLimitDuration = 2e3), e.hasOwnProperty("started") || (e.started = new Date().getTime()), this.throttledSaves && this.throttledSavePending) {
          if (!e.recursiveWait) return void this.throttledCallbacks.push(t);
          this.throttledCallbacks.push(function () {
            return i.throttledSavePending ? e.recursiveWaitLimit && r - e.started > e.recursiveWaitLimitDuration ? void t(!1) : void i.throttledSaveDrain(t, e) : void t(!0);
          });
        } else t(!0);
      }, g.prototype.loadDatabaseInternal = function (t, e) {
        var i = e || function (t, e) {
          if (t) throw t;
        },
            r = this;

        null !== this.persistenceAdapter ? this.persistenceAdapter.loadDatabase(this.filename, function (e) {
          if ("string" == typeof e) {
            var n = !1;

            try {
              r.loadJSON(e, t || {}), n = !0;
            } catch (t) {
              i(t);
            }

            n && (i(null), r.emit("loaded", "database " + r.filename + " loaded"));
          } else {
            if (!e) return i(null), void r.emit("loaded", "empty database " + r.filename + " loaded");
            if (e instanceof Error) return void i(e);
            if ("object" == typeof e) return r.loadJSONObject(e, t || {}), i(null), void r.emit("loaded", "database " + r.filename + " loaded");
            i("unexpected adapter response : " + e);
          }
        }) : i(new Error("persistenceAdapter not configured"));
      }, g.prototype.loadDatabase = function (t, e) {
        var i = this;
        this.throttledSaves ? this.throttledSaveDrain(function (r) {
          if (r) return i.throttledSavePending = !0, void i.loadDatabaseInternal(t, function (t) {
            0 === i.throttledCallbacks.length ? i.throttledSavePending = !1 : i.saveDatabase(), "function" == typeof e && e(t);
          });
          "function" == typeof e && e(new Error("Unable to pause save throttling long enough to read database"));
        }, t) : this.loadDatabaseInternal(t, e);
      }, g.prototype.saveDatabaseInternal = function (t) {
        var e = t || function (t) {
          if (t) throw t;
        },
            i = this;

        null !== this.persistenceAdapter ? "reference" === this.persistenceAdapter.mode && "function" == typeof this.persistenceAdapter.exportDatabase ? this.persistenceAdapter.exportDatabase(this.filename, this.copy({
          removeNonSerializable: !0
        }), function (t) {
          i.autosaveClearFlags(), e(t);
        }) : (i.autosaveClearFlags(), this.persistenceAdapter.saveDatabase(this.filename, i.serialize(), function (t) {
          e(t);
        })) : e(new Error("persistenceAdapter not configured"));
      }, g.prototype.saveDatabase = function (t) {
        if (this.throttledSaves) {
          if (this.throttledSavePending) this.throttledCallbacks.push(t);else {
            var e = this.throttledCallbacks;
            this.throttledCallbacks = [], e.unshift(t), this.throttledSavePending = !0;
            var i = this;
            this.saveDatabaseInternal(function (t) {
              i.throttledSavePending = !1, e.forEach(function (e) {
                "function" == typeof e && setTimeout(function () {
                  e(t);
                }, 1);
              }), i.throttledCallbacks.length > 0 && i.saveDatabase();
            });
          }
        } else this.saveDatabaseInternal(t);
      }, g.prototype.save = g.prototype.saveDatabase, g.prototype.deleteDatabase = function (t, e) {
        var i = e || function (t, e) {
          if (t) throw t;
        };

        "function" != typeof t || e || (i = t), null !== this.persistenceAdapter ? this.persistenceAdapter.deleteDatabase(this.filename, function (t) {
          i(t);
        }) : i(new Error("persistenceAdapter not configured"));
      }, g.prototype.autosaveDirty = function () {
        for (var t = 0; t < this.collections.length; t++) if (this.collections[t].dirty) return !0;

        return !1;
      }, g.prototype.autosaveClearFlags = function () {
        for (var t = 0; t < this.collections.length; t++) this.collections[t].dirty = !1;
      }, g.prototype.autosaveEnable = function (t, e) {
        this.autosave = !0;
        var i = 5e3,
            r = this;
        void 0 !== this.autosaveInterval && null !== this.autosaveInterval && (i = this.autosaveInterval), this.autosaveHandle = setInterval(function () {
          r.autosaveDirty() && r.saveDatabase(e);
        }, i);
      }, g.prototype.autosaveDisable = function () {
        void 0 !== this.autosaveHandle && null !== this.autosaveHandle && (clearInterval(this.autosaveHandle), this.autosaveHandle = null);
      }, O.prototype.reset = function () {
        return this.filteredrows.length > 0 && (this.filteredrows = []), this.filterInitialized = !1, this;
      }, O.prototype.toJSON = function () {
        var t = this.copy();
        return t.collection = null, t;
      }, O.prototype.limit = function (t) {
        this.filterInitialized || 0 !== this.filteredrows.length || (this.filteredrows = this.collection.prepareFullDocIndex());
        var e = new O(this.collection);
        return e.filteredrows = this.filteredrows.slice(0, t), e.filterInitialized = !0, e;
      }, O.prototype.offset = function (t) {
        this.filterInitialized || 0 !== this.filteredrows.length || (this.filteredrows = this.collection.prepareFullDocIndex());
        var e = new O(this.collection);
        return e.filteredrows = this.filteredrows.slice(t), e.filterInitialized = !0, e;
      }, O.prototype.copy = function () {
        var t = new O(this.collection);
        return this.filteredrows.length > 0 && (t.filteredrows = this.filteredrows.slice()), t.filterInitialized = this.filterInitialized, t;
      }, O.prototype.branch = O.prototype.copy, O.prototype.transform = function (t, i) {
        var r,
            n,
            o = this;
        if ("string" == typeof t && this.collection.transforms.hasOwnProperty(t) && (t = this.collection.transforms[t]), "object" != typeof t || !Array.isArray(t)) throw new Error("Invalid transform");

        for (void 0 !== i && (t = e.resolveTransformParams(t, i)), r = 0; r < t.length; r++) switch ((n = t[r]).type) {
          case "find":
            o.find(n.value);
            break;

          case "where":
            o.where(n.value);
            break;

          case "simplesort":
            o.simplesort(n.property, n.desc || n.options);
            break;

          case "compoundsort":
            o.compoundsort(n.value);
            break;

          case "sort":
            o.sort(n.value);
            break;

          case "limit":
            o = o.limit(n.value);
            break;

          case "offset":
            o = o.offset(n.value);
            break;

          case "map":
            o = o.map(n.value, n.dataOptions);
            break;

          case "eqJoin":
            o = o.eqJoin(n.joinData, n.leftJoinKey, n.rightJoinKey, n.mapFun, n.dataOptions);
            break;

          case "mapReduce":
            o = o.mapReduce(n.mapFunction, n.reduceFunction);
            break;

          case "update":
            o.update(n.value);
            break;

          case "remove":
            o.remove();
        }

        return o;
      }, O.prototype.sort = function (t) {
        this.filterInitialized || 0 !== this.filteredrows.length || (this.filteredrows = this.collection.prepareFullDocIndex());
        var e,
            i,
            r = (e = t, i = this.collection.data, function (t, r) {
          return e(i[t], i[r]);
        });
        return this.filteredrows.sort(r), this;
      }, O.prototype.simplesort = function (t, i) {
        var r,
            n = 10,
            o = this.collection.data.length,
            s = this.filteredrows.length,
            a = this.collection.binaryIndices.hasOwnProperty(t);

        if (void 0 !== i && !1 !== i || (i = {
          desc: !1
        }), !0 === i && (i = {
          desc: !0
        }), 0 === s) {
          if (this.filterInitialized) return this;
          if (this.collection.binaryIndices.hasOwnProperty(t)) return this.collection.ensureIndex(t), this.filteredrows = this.collection.binaryIndices[t].values.slice(0), i.desc && this.filteredrows.reverse(), this;
          this.filteredrows = this.collection.prepareFullDocIndex();
        } else if (!i.disableIndexIntersect && a && (r = o / s, i.useJavascriptSorting && (n = 6), r <= n || i.forceIndexIntersect)) {
          var h,
              c = this.filteredrows,
              u = {};

          for (h = 0; h < s; h++) u[c[h]] = !0;

          var d = this.collection.binaryIndices[t].values;
          return this.filteredrows = d.filter(function (t) {
            return u[t];
          }), i.desc && this.filteredrows.reverse(), this;
        }

        if (i.useJavascriptSorting) return this.sort(function (e, i) {
          return e[t] === i[t] ? 0 : e[t] > i[t] ? 1 : e[t] < i[t] ? -1 : void 0;
        });
        var p,
            f,
            y,
            v,
            g,
            m,
            b = (p = t, f = i.desc, y = this.collection.data, function (t, i) {
          return ~p.indexOf(".") ? (m = p.split("."), v = e.getIn(y[t], m, !0), g = e.getIn(y[i], m, !0)) : (v = y[t][p], g = y[i][p]), l(v, g, f);
        });
        return this.filteredrows.sort(b), this;
      }, O.prototype.compoundsort = function (t) {
        if (0 === t.length) throw new Error("Invalid call to compoundsort, need at least one property");
        var i;
        if (1 === t.length) return i = t[0], Array.isArray(i) ? this.simplesort(i[0], i[1]) : this.simplesort(i, !1);

        for (var r = 0, n = t.length; r < n; r += 1) i = t[r], Array.isArray(i) || (t[r] = [i, !1]);

        this.filterInitialized || 0 !== this.filteredrows.length || (this.filteredrows = this.collection.prepareFullDocIndex());
        var o,
            s,
            a = (o = t, s = this.collection.data, function (t, i) {
          return function (t, i, r) {
            for (var n, o, s, a, h, c = 0, u = 0, d = t.length; u < d; u++) if (n = t[u], ~(o = n[0]).indexOf(".") ? (h = o.split("."), s = e.getIn(i, h, !0), a = e.getIn(r, h, !0)) : (s = i[o], a = r[o]), 0 !== (c = l(s, a, n[1]))) return c;

            return 0;
          }(o, s[t], s[i]);
        });
        return this.filteredrows.sort(a), this;
      }, O.prototype.findOr = function (t) {
        for (var e = null, i = 0, r = 0, n = [], o = [], s = 0, a = (this.count(), 0), l = t.length; a < l; a++) for (e = this.branch().find(t[a]).filteredrows, r = e.length, i = 0; i < r; i++) s = e[i], void 0 === o[s] && (o[s] = !0, n.push(s));

        return this.filteredrows = n, this.filterInitialized = !0, this;
      }, O.prototype.$or = O.prototype.findOr, O.prototype.findAnd = function (t) {
        for (var e = 0, i = t.length; e < i; e++) {
          if (0 === this.count()) return this;
          this.find(t[e]);
        }

        return this;
      }, O.prototype.$and = O.prototype.findAnd, O.prototype.find = function (i, r) {
        if (0 === this.collection.data.length) return this.filteredrows = [], this.filterInitialized = !0, this;
        var n,
            o,
            s,
            a,
            l,
            c,
            u,
            f = i || "getAll",
            y = !1,
            v = [],
            g = [],
            m = null;

        if (r = r || !1, "object" == typeof f) {
          for (n in f) (a = {})[n] = f[n], g.push(a), t.call(f, n) && (o = n, s = f[n]);

          if (g.length > 1) return this.find({
            $and: g
          }, r);
        }

        if (!o || "getAll" === f) return r && (this.filterInitialized ? this.filteredrows = this.filteredrows.slice(0, 1) : (this.filteredrows = this.collection.data.length > 0 ? [0] : [], this.filterInitialized = !0)), this;
        if ("$and" === o || "$or" === o) return this[o](s), r && this.filteredrows.length > 1 && (this.filteredrows = this.filteredrows.slice(0, 1)), this;
        if (null === s || "object" != typeof s || s instanceof Date) l = "$eq", c = s;else {
          if ("object" != typeof s) throw new Error("Do not know what you want to do.");

          for (u in s) if (t.call(s, u)) {
            l = u, c = s[u];
            break;
          }
        }
        "$regex" !== l && "object" != typeof c || (c = function t(e, i) {
          if ("$regex" === e) Array.isArray(i) ? i = new RegExp(i[0], i[1]) : i instanceof RegExp || (i = new RegExp(i));else if ("object" == typeof i) for (var r in i) "$regex" !== r && "object" != typeof i[r] || (i[r] = t(r, i[r]));
          return i;
        }(l, c));
        var b = -1 !== o.indexOf("."),
            w = !this.filterInitialized;
        w && this.collection.binaryIndices[o] && p[l] && (!0 !== this.collection.adaptiveBinaryIndices && this.collection.ensureIndex(o), y = !0, m = this.collection.binaryIndices[o]);
        var I,
            O = d[l],
            x = this.collection.data,
            k = 0,
            D = 0,
            S = 0;

        if (this.filterInitialized) {
          if (I = this.filteredrows, D = I.length, b) {
            for (o = o.split("."), k = 0; k < D; k++) if (S = I[k], h(x[S], o, O, c) && (v.push(S), r)) return this.filteredrows = v, this;
          } else for (k = 0; k < D; k++) if (S = I[k], O(x[S][o], c) && (v.push(S), r)) return this.filteredrows = v, this;
        } else if (y) {
          var P = this.collection.calculateRange(l, o, c);

          if ("$in" !== l) {
            for (k = P[0]; k <= P[1]; k++) if (!0 !== p[l]) {
              if (p[l](e.getIn(x[m.values[k]], o, b), c) && (v.push(m.values[k]), r)) return this.filteredrows = v, this.filterInitialized = !0, this;
            } else if (v.push(m.values[k]), r) return this.filteredrows = v, this.filterInitialized = !0, this;
          } else for (k = 0, D = P.length; k < D; k++) if (v.push(m.values[P[k]]), r) return this.filteredrows = v, this.filterInitialized = !0, this;
        } else if (D = x.length, b) {
          for (o = o.split("."), k = 0; k < D; k++) if (h(x[k], o, O, c) && (v.push(k), r)) return this.filteredrows = v, this.filterInitialized = !0, this;
        } else for (k = 0; k < D; k++) if (O(x[k][o], c) && (v.push(k), r)) return this.filteredrows = v, this.filterInitialized = !0, this;

        return this.filteredrows = v, this.filterInitialized = !0, this;
      }, O.prototype.where = function (t) {
        var e,
            i = [];
        if ("function" != typeof t) throw new TypeError("Argument is not a stored view or a function");
        e = t;

        try {
          if (this.filterInitialized) {
            for (var r = this.filteredrows.length; r--;) !0 === e(this.collection.data[this.filteredrows[r]]) && i.push(this.filteredrows[r]);

            return this.filteredrows = i, this;
          }

          for (var n = this.collection.data.length; n--;) !0 === e(this.collection.data[n]) && i.push(n);

          return this.filteredrows = i, this.filterInitialized = !0, this;
        } catch (t) {
          throw t;
        }
      }, O.prototype.count = function () {
        return this.filterInitialized ? this.filteredrows.length : this.collection.count();
      }, O.prototype.data = function (t) {
        var e,
            i,
            r,
            n,
            o = [],
            s = this.collection.data;

        if ((t = t || {}).removeMeta && !t.forceClones && (t.forceClones = !0, t.forceCloneMethod = t.forceCloneMethod || "shallow"), this.collection.disableDeltaChangesApi || (t.forceClones = !0, t.forceCloneMethod = "parse-stringify"), !this.filterInitialized) {
          if (0 === this.filteredrows.length) {
            if (this.collection.cloneObjects || t.forceClones) {
              for (i = s.length, n = t.forceCloneMethod || this.collection.cloneMethod, r = 0; r < i; r++) e = f(s[r], n), t.removeMeta && (delete e.$loki, delete e.meta), o.push(e);

              return o;
            }

            return s.slice();
          }

          this.filterInitialized = !0;
        }

        var a = this.filteredrows;
        if (i = a.length, this.collection.cloneObjects || t.forceClones) for (n = t.forceCloneMethod || this.collection.cloneMethod, r = 0; r < i; r++) e = f(s[a[r]], n), t.removeMeta && (delete e.$loki, delete e.meta), o.push(e);else for (r = 0; r < i; r++) o.push(s[a[r]]);
        return o;
      }, O.prototype.update = function (t) {
        if ("function" != typeof t) throw new TypeError("Argument is not a function");
        this.filterInitialized || 0 !== this.filteredrows.length || (this.filteredrows = this.collection.prepareFullDocIndex());

        for (var e, i = this.filteredrows.length, r = this.collection.data, n = 0; n < i; n++) this.collection.cloneObjects || !this.collection.disableDeltaChangesApi ? (e = f(r[this.filteredrows[n]], this.collection.cloneMethod), t(e), this.collection.update(e)) : (t(r[this.filteredrows[n]]), this.collection.update(r[this.filteredrows[n]]));

        return this;
      }, O.prototype.remove = function () {
        return this.filterInitialized || 0 !== this.filteredrows.length || (this.filteredrows = this.collection.prepareFullDocIndex()), this.collection.removeBatchByPositions(this.filteredrows), this.filteredrows = [], this;
      }, O.prototype.mapReduce = function (t, e) {
        try {
          return e(this.data().map(t));
        } catch (t) {
          throw t;
        }
      }, O.prototype.eqJoin = function (t, e, i, r, n) {
        var o,
            s,
            a,
            l = [],
            h = [],
            c = [],
            u = "function" == typeof e,
            d = "function" == typeof i,
            p = {};
        if (l = this.data(n), o = l.length, t instanceof k) h = t.chain().data(n);else if (t instanceof O) h = t.data(n);else {
          if (!Array.isArray(t)) throw new TypeError("joinData needs to be an array or result set");
          h = t;
        }
        s = h.length;

        for (var f = 0; f < s; f++) a = d ? i(h[f]) : h[f][i], p[a] = h[f];

        r || (r = function (t, e) {
          return {
            left: t,
            right: e
          };
        });

        for (var y = 0; y < o; y++) a = u ? e(l[y]) : l[y][e], c.push(r(l[y], p[a] || {}));

        return this.collection = new k("joinData"), this.collection.insert(c), this.filteredrows = [], this.filterInitialized = !1, this;
      }, O.prototype.map = function (t, e) {
        var i = this.data(e).map(t);
        return this.collection = new k("mappedData"), this.collection.insert(i), this.filteredrows = [], this.filterInitialized = !1, this;
      }, x.prototype = new v(), x.prototype.rematerialize = function (t) {
        var e, i, r;
        if (t = t || {}, this.resultdata = [], this.resultsdirty = !0, this.resultset = new O(this.collection), (this.sortFunction || this.sortCriteria || this.sortCriteriaSimple) && (this.sortDirty = !0), t.hasOwnProperty("removeWhereFilters")) for (e = this.filterPipeline.length, i = e; i--;) "where" === this.filterPipeline[i].type && (i !== this.filterPipeline.length - 1 && (this.filterPipeline[i] = this.filterPipeline[this.filterPipeline.length - 1]), this.filterPipeline.length--);
        var n = this.filterPipeline;

        for (this.filterPipeline = [], e = n.length, r = 0; r < e; r++) this.applyFind(n[r].val);

        return this.data(), this.emit("rebuild", this), this;
      }, x.prototype.branchResultset = function (t, e) {
        var i = this.resultset.branch();
        return void 0 === t ? i : i.transform(t, e);
      }, x.prototype.toJSON = function () {
        var t = new x(this.collection, this.name, this.options);
        return t.resultset = this.resultset, t.resultdata = [], t.resultsdirty = !0, t.filterPipeline = this.filterPipeline, t.sortFunction = this.sortFunction, t.sortCriteria = this.sortCriteria, t.sortCriteriaSimple = this.sortCriteriaSimple || null, t.sortDirty = this.sortDirty, t.collection = null, t;
      }, x.prototype.removeFilters = function (t) {
        t = t || {}, this.rebuildPending = !1, this.resultset.reset(), this.resultdata = [], this.resultsdirty = !0, this.cachedresultset = null, this.filterPipeline = [], this.sortFunction = null, this.sortCriteria = null, this.sortCriteriaSimple = null, this.sortDirty = !1, !0 === t.queueSortPhase && this.queueSortPhase();
      }, x.prototype.applySort = function (t) {
        return this.sortFunction = t, this.sortCriteria = null, this.sortCriteriaSimple = null, this.queueSortPhase(), this;
      }, x.prototype.applySimpleSort = function (t, e) {
        return this.sortCriteriaSimple = {
          propname: t,
          options: e || !1
        }, this.sortCriteria = null, this.sortFunction = null, this.queueSortPhase(), this;
      }, x.prototype.applySortCriteria = function (t) {
        return this.sortCriteria = t, this.sortCriteriaSimple = null, this.sortFunction = null, this.queueSortPhase(), this;
      }, x.prototype.startTransaction = function () {
        return this.cachedresultset = this.resultset.copy(), this;
      }, x.prototype.commit = function () {
        return this.cachedresultset = null, this;
      }, x.prototype.rollback = function () {
        return this.resultset = this.cachedresultset, this.options.persistent && (this.resultdata = this.resultset.data(), this.emit("rebuild", this)), this;
      }, x.prototype._indexOfFilterWithId = function (t) {
        if ("string" == typeof t || "number" == typeof t) for (var e = 0, i = this.filterPipeline.length; e < i; e += 1) if (t === this.filterPipeline[e].uid) return e;
        return -1;
      }, x.prototype._addFilter = function (t) {
        this.filterPipeline.push(t), this.resultset[t.type](t.val);
      }, x.prototype.reapplyFilters = function () {
        this.resultset.reset(), this.cachedresultset = null, this.options.persistent && (this.resultdata = [], this.resultsdirty = !0);
        var t = this.filterPipeline;
        this.filterPipeline = [];

        for (var e = 0, i = t.length; e < i; e += 1) this._addFilter(t[e]);

        return this.sortFunction || this.sortCriteria || this.sortCriteriaSimple ? this.queueSortPhase() : this.queueRebuildEvent(), this;
      }, x.prototype.applyFilter = function (t) {
        var e = this._indexOfFilterWithId(t.uid);

        return e >= 0 ? (this.filterPipeline[e] = t, this.reapplyFilters()) : (this.cachedresultset = null, this.options.persistent && (this.resultdata = [], this.resultsdirty = !0), this._addFilter(t), this.sortFunction || this.sortCriteria || this.sortCriteriaSimple ? this.queueSortPhase() : this.queueRebuildEvent(), this);
      }, x.prototype.applyFind = function (t, e) {
        return this.applyFilter({
          type: "find",
          val: t,
          uid: e
        }), this;
      }, x.prototype.applyWhere = function (t, e) {
        return this.applyFilter({
          type: "where",
          val: t,
          uid: e
        }), this;
      }, x.prototype.removeFilter = function (t) {
        var e = this._indexOfFilterWithId(t);

        if (e < 0) throw new Error("Dynamic view does not contain a filter with ID: " + t);
        return this.filterPipeline.splice(e, 1), this.reapplyFilters(), this;
      }, x.prototype.count = function () {
        return this.resultsdirty && (this.resultdata = this.resultset.data()), this.resultset.count();
      }, x.prototype.data = function (t) {
        return (this.sortDirty || this.resultsdirty) && this.performSortPhase({
          suppressRebuildEvent: !0
        }), this.options.persistent ? this.resultdata : this.resultset.data(t);
      }, x.prototype.queueRebuildEvent = function () {
        if (!this.rebuildPending) {
          this.rebuildPending = !0;
          var t = this;
          setTimeout(function () {
            t.rebuildPending && (t.rebuildPending = !1, t.emit("rebuild", t));
          }, this.options.minRebuildInterval);
        }
      }, x.prototype.queueSortPhase = function () {
        if (!this.sortDirty) {
          this.sortDirty = !0;
          var t = this;
          "active" === this.options.sortPriority ? setTimeout(function () {
            t.performSortPhase();
          }, this.options.minRebuildInterval) : this.queueRebuildEvent();
        }
      }, x.prototype.performSortPhase = function (t) {
        (this.sortDirty || this.resultsdirty) && (t = t || {}, this.sortDirty && (this.sortFunction ? this.resultset.sort(this.sortFunction) : this.sortCriteria ? this.resultset.compoundsort(this.sortCriteria) : this.sortCriteriaSimple && this.resultset.simplesort(this.sortCriteriaSimple.propname, this.sortCriteriaSimple.options), this.sortDirty = !1), this.options.persistent && (this.resultdata = this.resultset.data(), this.resultsdirty = !1), t.suppressRebuildEvent || this.emit("rebuild", this));
      }, x.prototype.evaluateDocument = function (t, e) {
        if (!this.resultset.filterInitialized) return this.options.persistent && (this.resultdata = this.resultset.data()), void (this.sortFunction || this.sortCriteria || this.sortCriteriaSimple ? this.queueSortPhase() : this.queueRebuildEvent());
        var i,
            r = this.resultset.filteredrows,
            n = e ? -1 : r.indexOf(+t),
            o = r.length,
            s = new O(this.collection);
        s.filteredrows = [t], s.filterInitialized = !0;

        for (var a = 0, l = this.filterPipeline.length; a < l; a++) i = this.filterPipeline[a], s[i.type](i.val);

        var h = 0 === s.filteredrows.length ? -1 : 0;
        return -1 !== n || -1 !== h ? -1 === n && -1 !== h ? (r.push(t), this.options.persistent && this.resultdata.push(this.collection.data[t]), void (this.sortFunction || this.sortCriteria || this.sortCriteriaSimple ? this.queueSortPhase() : this.queueRebuildEvent())) : -1 !== n && -1 === h ? (n < o - 1 ? (r.splice(n, 1), this.options.persistent && this.resultdata.splice(n, 1)) : (r.length = o - 1, this.options.persistent && (this.resultdata.length = o - 1)), void (this.sortFunction || this.sortCriteria || this.sortCriteriaSimple ? this.queueSortPhase() : this.queueRebuildEvent())) : -1 !== n && -1 !== h ? (this.options.persistent && (this.resultdata[n] = this.collection.data[t]), void (this.sortFunction || this.sortCriteria || this.sortCriteriaSimple ? this.queueSortPhase() : this.queueRebuildEvent())) : void 0 : void 0;
      }, x.prototype.removeDocument = function (t) {
        var e,
            i,
            r,
            n = {},
            o = {},
            s = [],
            a = this.resultset,
            l = this.resultset.filteredrows,
            h = l.length;
        if (!this.resultset.filterInitialized) return this.options.persistent && (this.resultdata = this.resultset.data()), void (this.sortFunction || this.sortCriteria || this.sortCriteriaSimple ? this.queueSortPhase() : this.queueRebuildEvent());

        for (Array.isArray(t) || (t = [t]), r = t.length, i = 0; i < r; i++) n[t[i]] = !0;

        for (e = 0; e < h; e++) n[l[e]] && (o[e] = !0);

        Object.keys(o).length > 0 && (this.resultset.filteredrows = this.resultset.filteredrows.filter(function (t, e) {
          return !o[e];
        }), this.options.persistent && (this.resultdata = this.resultdata.filter(function (t, e) {
          return !o[e];
        })), this.sortFunction || this.sortCriteria || this.sortCriteriaSimple ? this.queueSortPhase() : this.queueRebuildEvent());

        var c = function (t) {
          return function (e) {
            return e < a.filteredrows[t];
          };
        };

        for (h = a.filteredrows.length, e = 0; e < h; e++) s = t.filter(c(e)), a.filteredrows[e] -= s.length;
      }, x.prototype.mapReduce = function (t, e) {
        try {
          return e(this.data().map(t));
        } catch (t) {
          throw t;
        }
      }, k.prototype = new v(), k.prototype.createChange = function (t, e, i, r) {
        this.changes.push({
          name: t,
          operation: e,
          obj: "U" != e || this.disableDeltaChangesApi ? JSON.parse(JSON.stringify(i)) : this.getChangeDelta(i, r)
        });
      }, k.prototype.insertMeta = function (t) {
        var e, i;
        if (!this.disableMeta && t) if (Array.isArray(t)) for (e = t.length, i = 0; i < e; i++) t[i].hasOwnProperty("meta") || (t[i].meta = {}), t[i].meta.created = new Date().getTime(), t[i].meta.revision = 0;else t.meta || (t.meta = {}), t.meta.created = new Date().getTime(), t.meta.revision = 0;
      }, k.prototype.updateMeta = function (t) {
        !this.disableMeta && t && (t.meta.updated = new Date().getTime(), t.meta.revision += 1);
      }, k.prototype.createInsertChange = function (t) {
        this.createChange(this.name, "I", t);
      }, k.prototype.createUpdateChange = function (t, e) {
        this.createChange(this.name, "U", t, e);
      }, k.prototype.insertMetaWithChange = function (t) {
        this.insertMeta(t), this.createInsertChange(t);
      }, k.prototype.updateMetaWithChange = function (t, e) {
        this.updateMeta(t), this.createUpdateChange(t, e);
      }, k.prototype.lokiConsoleWrapper = {
        log: function () {},
        warn: function () {},
        error: function () {}
      }, k.prototype.addAutoUpdateObserver = function (t) {
        this.autoupdate && "function" == typeof Object.observe && Object.observe(t, this.observerCallback, ["add", "update", "delete", "reconfigure", "setPrototype"]);
      }, k.prototype.removeAutoUpdateObserver = function (t) {
        this.autoupdate && "function" == typeof Object.observe && Object.unobserve(t, this.observerCallback);
      }, k.prototype.addTransform = function (t, e) {
        if (this.transforms.hasOwnProperty(t)) throw new Error("a transform by that name already exists");
        this.transforms[t] = e;
      }, k.prototype.getTransform = function (t) {
        return this.transforms[t];
      }, k.prototype.setTransform = function (t, e) {
        this.transforms[t] = e;
      }, k.prototype.removeTransform = function (t) {
        delete this.transforms[t];
      }, k.prototype.byExample = function (t) {
        var e, i, r;

        for (e in r = [], t) t.hasOwnProperty(e) && r.push(((i = {})[e] = t[e], i));

        return {
          $and: r
        };
      }, k.prototype.findObject = function (t) {
        return this.findOne(this.byExample(t));
      }, k.prototype.findObjects = function (t) {
        return this.find(this.byExample(t));
      }, k.prototype.ttlDaemonFuncGen = function () {
        var t = this,
            e = this.ttl.age;
        return function () {
          var i = Date.now(),
              r = t.chain().where(function (t) {
            var r = t.meta.updated || t.meta.created,
                n = i - r;
            return e < n;
          });
          r.remove();
        };
      }, k.prototype.setTTL = function (t, e) {
        t < 0 ? clearInterval(this.ttl.daemon) : (this.ttl.age = t, this.ttl.ttlInterval = e, this.ttl.daemon = setInterval(this.ttlDaemonFuncGen(), e));
      }, k.prototype.prepareFullDocIndex = function () {
        for (var t = this.data.length, e = new Array(t), i = 0; i < t; i += 1) e[i] = i;

        return e;
      }, k.prototype.configureOptions = function (t) {
        (t = t || {}).hasOwnProperty("adaptiveBinaryIndices") && (this.adaptiveBinaryIndices = t.adaptiveBinaryIndices, this.adaptiveBinaryIndices && this.ensureAllIndexes());
      }, k.prototype.ensureIndex = function (t, r) {
        if (void 0 === r && (r = !1), null == t) throw new Error("Attempting to set index without an associated property");

        if ((!this.binaryIndices[t] || r || this.binaryIndices[t].dirty) && (!0 !== this.adaptiveBinaryIndices || !this.binaryIndices.hasOwnProperty(t) || r)) {
          var n = {
            name: t,
            dirty: !0,
            values: this.prepareFullDocIndex()
          };
          this.binaryIndices[t] = n;
          var o,
              s,
              a,
              l,
              h,
              c = (o = t, s = this.data, function (t, r) {
            if (~o.indexOf(".") ? (h = o.split("."), a = e.getIn(s[t], h, !0), l = e.getIn(s[r], h, !0)) : (a = s[t][o], l = s[r][o]), a !== l) {
              if (i.lt(a, l, !1)) return -1;
              if (i.gt(a, l, !1)) return 1;
            }

            return 0;
          });
          n.values.sort(c), n.dirty = !1, this.dirty = !0;
        }
      }, k.prototype.checkAllIndexes = function (e) {
        var i,
            r = this.binaryIndices,
            n = [];

        for (i in r) t.call(r, i) && (this.checkIndex(i, e) || n.push(i));

        return n;
      }, k.prototype.checkIndex = function (t, i) {
        (i = i || {}).randomSamplingFactor && !1 !== i.randomSampling && (i.randomSampling = !0), i.randomSamplingFactor = i.randomSamplingFactor || .1, (i.randomSamplingFactor < 0 || i.randomSamplingFactor > 1) && (i.randomSamplingFactor = .1);
        var r,
            n,
            o,
            s,
            a,
            l = !0;
        if (!this.binaryIndices.hasOwnProperty(t)) throw new Error("called checkIndex on property without an index: " + t);
        if (this.adaptiveBinaryIndices || this.ensureIndex(t), a = this.binaryIndices[t].values, (s = a.length) !== this.data.length) return i.repair && this.ensureIndex(t, !0), !1;
        if (0 === s) return !0;
        var h = -1 !== t.indexOf(".");
        if (1 === s) l = 0 === a[0];else if (i.randomSampling) {
          if (d.$lte(e.getIn(this.data[a[0]], t, h), e.getIn(this.data[a[1]], t, h)) || (l = !1), d.$lte(e.getIn(this.data[a[s - 2]], t, h), e.getIn(this.data[a[s - 1]], t, h)) || (l = !1), l) for (n = Math.floor((s - 1) * i.randomSamplingFactor), r = 0; r < n - 1; r++) if (o = Math.floor(Math.random() * (s - 1)), !d.$lte(e.getIn(this.data[a[o]], t, h), e.getIn(this.data[a[o + 1]], t, h))) {
            l = !1;
            break;
          }
        } else for (r = 0; r < s - 1; r++) if (!d.$lte(e.getIn(this.data[a[r]], t, h), e.getIn(this.data[a[r + 1]], t, h))) {
          l = !1;
          break;
        }
        return !l && i.repair && this.ensureIndex(t, !0), l;
      }, k.prototype.getBinaryIndexValues = function (t) {
        var i,
            r = this.binaryIndices[t].values,
            n = [];

        for (i = 0; i < r.length; i++) n.push(e.getIn(this.data[r[i]], t, !0));

        return n;
      }, k.prototype.ensureUniqueIndex = function (t) {
        var e = this.constraints.unique[t];
        return e || -1 == this.uniqueNames.indexOf(t) && this.uniqueNames.push(t), this.constraints.unique[t] = e = new N(t), this.data.forEach(function (t) {
          e.set(t);
        }), e;
      }, k.prototype.ensureAllIndexes = function (e) {
        var i,
            r = this.binaryIndices;

        for (i in r) t.call(r, i) && this.ensureIndex(i, e);
      }, k.prototype.flagBinaryIndexesDirty = function () {
        var e,
            i = this.binaryIndices;

        for (e in i) t.call(i, e) && (i[e].dirty = !0);
      }, k.prototype.flagBinaryIndexDirty = function (t) {
        this.binaryIndices[t] && (this.binaryIndices[t].dirty = !0);
      }, k.prototype.count = function (t) {
        return t ? this.chain().find(t).filteredrows.length : this.data.length;
      }, k.prototype.ensureId = function () {
        var t = this.data.length,
            e = 0;

        for (this.idIndex = []; e < t; e += 1) this.idIndex.push(this.data[e].$loki);
      }, k.prototype.ensureIdAsync = function (t) {
        this.async(function () {
          this.ensureId();
        }, t);
      }, k.prototype.addDynamicView = function (t, e) {
        var i = new x(this, t, e);
        return this.DynamicViews.push(i), i;
      }, k.prototype.removeDynamicView = function (t) {
        this.DynamicViews = this.DynamicViews.filter(function (e) {
          return e.name !== t;
        });
      }, k.prototype.getDynamicView = function (t) {
        for (var e = 0; e < this.DynamicViews.length; e++) if (this.DynamicViews[e].name === t) return this.DynamicViews[e];

        return null;
      }, k.prototype.findAndUpdate = function (t, e) {
        "function" == typeof t ? this.updateWhere(t, e) : this.chain().find(t).update(e);
      }, k.prototype.findAndRemove = function (t) {
        this.chain().find(t).remove();
      }, k.prototype.insert = function (t) {
        if (!Array.isArray(t)) return this.insertOne(t);
        var e,
            i = [];
        this.emit("pre-insert", t);

        for (var r = 0, n = t.length; r < n; r++) {
          if (!(e = this.insertOne(t[r], !0))) return;
          i.push(e);
        }

        return this.emit("insert", i), 1 === (i = this.cloneObjects ? f(i, this.cloneMethod) : i).length ? i[0] : i;
      }, k.prototype.insertOne = function (t, e) {
        var i,
            r = null;
        if ("object" != typeof t ? r = new TypeError("Document needs to be an object") : null === t && (r = new TypeError("Object cannot be null")), null !== r) throw this.emit("error", r), r;
        var n = this.cloneObjects ? f(t, this.cloneMethod) : t;
        if (this.disableMeta || void 0 !== n.meta || (n.meta = {
          revision: 0,
          created: 0
        }), e || this.emit("pre-insert", n), this.add(n)) return this.disableChangesApi ? this.insertMeta(n) : this.insertMetaWithChange(n), i = this.cloneObjects ? f(n, this.cloneMethod) : n, e || this.emit("insert", i), this.addAutoUpdateObserver(i), i;
      }, k.prototype.clear = function (t) {
        var e = this;
        if (t = t || {}, this.data = [], this.idIndex = [], this.cachedIndex = null, this.cachedBinaryIndex = null, this.cachedData = null, this.maxId = 0, this.DynamicViews = [], this.dirty = !0, !0 === t.removeIndices) this.binaryIndices = {}, this.constraints = {
          unique: {},
          exact: {}
        }, this.uniqueNames = [];else {
          var i = Object.keys(this.binaryIndices);
          i.forEach(function (t) {
            e.binaryIndices[t].dirty = !1, e.binaryIndices[t].values = [];
          }), this.constraints = {
            unique: {},
            exact: {}
          }, this.uniqueNames.forEach(function (t) {
            e.ensureUniqueIndex(t);
          });
        }
      }, k.prototype.update = function (e) {
        var i, r, n;

        if (Array.isArray(e)) {
          n = e.length, (i = !this.cloneObjects && this.adaptiveBinaryIndices && Object.keys(this.binaryIndices).length > 0) && (this.adaptiveBinaryIndices = !1);

          try {
            for (r = 0; r < n; r += 1) this.update(e[r]);
          } finally {
            i && (this.ensureAllIndexes(), this.adaptiveBinaryIndices = !0);
          }
        } else {
          if (!t.call(e, "$loki")) throw new Error("Trying to update unsynced document. Please save the document first by using insert() or addMany()");

          try {
            this.startTransaction();
            var o,
                s,
                a,
                l,
                h,
                c = this.get(e.$loki, !0),
                u = this;
            if (!c) throw new Error("Trying to update a document not in collection.");
            o = c[0], a = c[1], s = this.cloneObjects || !this.disableDeltaChangesApi ? f(e, this.cloneMethod) : e, this.emit("pre-update", e), Object.keys(this.constraints.unique).forEach(function (t) {
              u.constraints.unique[t].update(o, s);
            }), this.data[a] = s, s !== e && this.addAutoUpdateObserver(e);

            for (var d = 0; d < this.DynamicViews.length; d++) this.DynamicViews[d].evaluateDocument(a, !1);

            if (this.adaptiveBinaryIndices) {
              var p = this.binaryIndices;

              for (l in p) this.adaptiveBinaryIndexUpdate(a, l);
            } else this.flagBinaryIndexesDirty();

            return this.idIndex[a] = s.$loki, this.commit(), this.dirty = !0, this.disableChangesApi ? this.updateMeta(s, null) : this.updateMetaWithChange(s, o), h = this.cloneObjects ? f(s, this.cloneMethod) : s, this.emit("update", h, o), h;
          } catch (t) {
            throw this.rollback(), this.lokiConsoleWrapper.error(t.message), this.emit("error", t), t;
          }
        }
      }, k.prototype.add = function (e) {
        if ("object" != typeof e) throw new TypeError("Object being added needs to be an object");
        if (void 0 !== e.$loki) throw new Error("Document is already in collection, please use update()");

        try {
          this.startTransaction(), this.maxId++, isNaN(this.maxId) && (this.maxId = this.data[this.data.length - 1].$loki + 1), e.$loki = this.maxId, this.disableMeta || (e.meta.version = 0);
          var i,
              r = this.constraints.unique;

          for (i in r) t.call(r, i) && r[i].set(e);

          this.idIndex.push(e.$loki), this.data.push(e);

          for (var n = this.data.length - 1, o = this.DynamicViews.length, s = 0; s < o; s++) this.DynamicViews[s].evaluateDocument(n, !0);

          if (this.adaptiveBinaryIndices) {
            var a = this.binaryIndices;

            for (i in a) this.adaptiveBinaryIndexInsert(n, i);
          } else this.flagBinaryIndexesDirty();

          return this.commit(), this.dirty = !0, this.cloneObjects ? f(e, this.cloneMethod) : e;
        } catch (t) {
          throw this.rollback(), this.lokiConsoleWrapper.error(t.message), this.emit("error", t), t;
        }
      }, k.prototype.updateWhere = function (t, e) {
        var i,
            r = this.where(t),
            n = 0;

        try {
          for (; n < r.length; n++) i = e(r[n]), this.update(i);
        } catch (t) {
          this.rollback(), this.lokiConsoleWrapper.error(t.message);
        }
      }, k.prototype.removeWhere = function (t) {
        var e;
        "function" == typeof t ? (e = this.data.filter(t), this.remove(e)) : this.chain().find(t).remove();
      }, k.prototype.removeDataOnly = function () {
        this.remove(this.data.slice());
      }, k.prototype.removeBatchByPositions = function (t) {
        var e,
            i,
            r,
            n,
            o = t.length,
            s = {},
            a = Object.keys(this.binaryIndices).length,
            l = Object.keys(this.constraints.unique).length,
            h = this.adaptiveBinaryIndices && Object.keys(this.binaryIndices).length > 0,
            c = this;

        try {
          for (this.startTransaction(), r = 0; r < o; r++) s[this.idIndex[t[r]]] = !0;

          if ((e = this.DynamicViews.length) > 0 || a > 0 || l > 0) {
            if (e > 0) for (i = 0; i < e; i++) this.DynamicViews[i].removeDocument(t);

            if (this.adaptiveBinaryIndices && !h) {
              var u,
                  d = this.binaryIndices;

              for (u in d) this.adaptiveBinaryIndexRemove(t, u);
            } else this.flagBinaryIndexesDirty();

            l && Object.keys(this.constraints.unique).forEach(function (e) {
              for (r = 0; r < o; r++) null !== (n = c.data[t[r]])[e] && void 0 !== n[e] && c.constraints.unique[e].remove(n[e]);
            });
          }

          if (!this.disableChangesApi || this.events.delete.length > 1) for (r = 0; r < o; r++) this.emit("delete", this.data[t[r]]);
          this.data = this.data.filter(function (t) {
            return !s[t.$loki];
          }), this.idIndex = this.idIndex.filter(function (t) {
            return !s[t];
          }), this.adaptiveBinaryIndices && h && (this.adaptiveBinaryIndices = !1, this.ensureAllIndexes(!0), this.adaptiveBinaryIndices = !0), this.commit(), this.dirty = !0;
        } catch (t) {
          return this.rollback(), h && (this.adaptiveBinaryIndices = !0), this.lokiConsoleWrapper.error(t.message), this.emit("error", t), null;
        }
      }, k.prototype.removeBatch = function (t) {
        var e,
            i = t.length,
            r = this.data.length,
            n = {},
            o = [];

        for (e = 0; e < r; e++) n[this.data[e].$loki] = e;

        for (e = 0; e < i; e++) "object" == typeof t[e] ? o.push(n[t[e].$loki]) : o.push(n[t[e]]);

        this.removeBatchByPositions(o);
      }, k.prototype.remove = function (e) {
        if ("number" == typeof e && (e = this.get(e)), "object" != typeof e) throw new Error("Parameter is not an object");
        if (Array.isArray(e)) this.removeBatch(e);else {
          if (!t.call(e, "$loki")) throw new Error("Object is not a document stored in the collection");

          try {
            this.startTransaction();
            var i = this.get(e.$loki, !0),
                r = i[1],
                n = this;
            Object.keys(this.constraints.unique).forEach(function (t) {
              null !== e[t] && void 0 !== e[t] && n.constraints.unique[t].remove(e[t]);
            });

            for (var o = 0; o < this.DynamicViews.length; o++) this.DynamicViews[o].removeDocument(r);

            if (this.adaptiveBinaryIndices) {
              var s,
                  a = this.binaryIndices;

              for (s in a) this.adaptiveBinaryIndexRemove(r, s);
            } else this.flagBinaryIndexesDirty();

            return this.data.splice(r, 1), this.removeAutoUpdateObserver(e), this.idIndex.splice(r, 1), this.commit(), this.dirty = !0, this.emit("delete", i[0]), delete e.$loki, delete e.meta, e;
          } catch (t) {
            return this.rollback(), this.lokiConsoleWrapper.error(t.message), this.emit("error", t), null;
          }
        }
      }, k.prototype.get = function (t, e) {
        var i = e || !1,
            r = this.idIndex,
            n = r.length - 1,
            o = 0,
            s = o + n >> 1;
        if (t = "number" == typeof t ? t : parseInt(t, 10), isNaN(t)) throw new TypeError("Passed id is not an integer");

        for (; r[o] < r[n];) r[s = o + n >> 1] < t ? o = s + 1 : n = s;

        return n === o && r[o] === t ? i ? [this.data[o], o] : this.data[o] : null;
      }, k.prototype.getBinaryIndexPosition = function (t, i) {
        var r = e.getIn(this.data[t], i, !0),
            n = this.binaryIndices[i].values,
            o = this.calculateRange("$eq", i, r);
        if (0 === o[0] && -1 === o[1]) return null;

        for (var s = o[0], a = o[1], l = s; l <= a; l++) if (n[l] === t) return l;

        return null;
      }, k.prototype.adaptiveBinaryIndexInsert = function (t, i) {
        var r = -1 !== i.indexOf("."),
            n = this.binaryIndices[i].values,
            o = e.getIn(this.data[t], i, r);
        !0 === this.serializableIndices && o instanceof Date && (this.data[t][i] = o.getTime(), o = e.getIn(this.data[t], i));
        var s = 0 === n.length ? 0 : this.calculateRangeStart(i, o, !0, r);
        this.binaryIndices[i].values.splice(s, 0, t);
      }, k.prototype.adaptiveBinaryIndexUpdate = function (t, e) {
        var i,
            r = this.binaryIndices[e].values,
            n = r.length;

        for (i = 0; i < n && r[i] !== t; i++);

        this.binaryIndices[e].values.splice(i, 1), this.adaptiveBinaryIndexInsert(t, e);
      }, k.prototype.adaptiveBinaryIndexRemove = function (t, e, i) {
        var r,
            n,
            o,
            s,
            a,
            l,
            h,
            c = this.binaryIndices[e],
            u = {};

        if (Array.isArray(t)) {
          if (1 !== (s = t.length)) {
            for (o = 0; o < s; o++) u[t[o]] = !0;

            if (c.values = c.values.filter(function (t) {
              return !u[t];
            }), !0 === i) return;
            var d = t.slice();

            for (d.sort(function (t, e) {
              return t - e;
            }), r = c.values.length, n = 0; n < r; n++) {
              for (a = c.values[n], l = 0, o = 0; o < s && a > d[o]; o++) l++;

              c.values[n] -= l;
            }

            return;
          }

          t = t[0];
        }

        if (null === (h = this.getBinaryIndexPosition(t, e))) return null;
        if (c.values.splice(h, 1), !0 !== i) for (r = c.values.length, n = 0; n < r; n++) c.values[n] > t && c.values[n]--;
      }, k.prototype.calculateRangeStart = function (t, r, n, o) {
        var s = this.data,
            a = this.binaryIndices[t].values,
            l = 0,
            h = a.length - 1,
            c = 0;
        if (0 === a.length) return -1;

        for (e.getIn(s[a[l]], t, o), e.getIn(s[a[h]], t, o); l < h;) c = l + h >> 1, i.lt(e.getIn(s[a[c]], t, o), r, !1) ? l = c + 1 : h = c;

        var u = l;
        return i.aeq(r, e.getIn(s[a[u]], t, o)) ? u : i.lt(r, e.getIn(s[a[u]], t, o), !1) ? n ? u : u - 1 : n ? u + 1 : u;
      }, k.prototype.calculateRangeEnd = function (t, r, n) {
        var o = this.data,
            s = this.binaryIndices[t].values,
            a = 0,
            l = s.length - 1,
            h = 0;
        if (0 === s.length) return -1;

        for (e.getIn(o[s[a]], t, n), e.getIn(o[s[l]], t, n); a < l;) h = a + l >> 1, i.lt(r, e.getIn(o[s[h]], t, n), !1) ? l = h : a = h + 1;

        var c = l;
        return i.aeq(r, e.getIn(o[s[c]], t, n)) ? c : i.gt(r, e.getIn(o[s[c]], t, n), !1) ? c + 1 : i.aeq(r, e.getIn(o[s[c - 1]], t, n)) ? c - 1 : c;
      }, k.prototype.calculateRange = function (t, r, n) {
        var o,
            s,
            a,
            l = this.data,
            h = this.binaryIndices[r].values,
            c = h.length - 1;
        if (0 === l.length) return [0, -1];
        var u = -1 !== r.indexOf("."),
            d = e.getIn(l[h[0]], r, u),
            p = e.getIn(l[h[c]], r, u);

        switch (t) {
          case "$eq":
          case "$aeq":
          case "$dteq":
            if (i.lt(n, d, !1) || i.gt(n, p, !1)) return [0, -1];
            break;

          case "$gt":
            if (i.gt(n, p, !0)) return [0, -1];
            if (i.gt(d, n, !1)) return [0, c];
            break;

          case "$gte":
            if (i.gt(n, p, !1)) return [0, -1];
            if (i.gt(d, n, !0)) return [0, c];
            break;

          case "$lt":
            if (i.lt(n, d, !0)) return [0, -1];
            if (i.lt(p, n, !1)) return [0, c];
            break;

          case "$lte":
            if (i.lt(n, d, !1)) return [0, -1];
            if (i.lt(p, n, !0)) return [0, c];
            break;

          case "$between":
            return i.gt(n[0], p, !1) ? [0, -1] : i.lt(n[1], d, !1) ? [0, -1] : (o = this.calculateRangeStart(r, n[0], !1, u), a = this.calculateRangeEnd(r, n[1], u), o < 0 && o++, a > c && a--, i.gt(e.getIn(l[h[o]], r, u), n[0], !0) || o++, i.lt(e.getIn(l[h[a]], r, u), n[1], !0) || a--, a < o ? [0, -1] : [o, a]);

          case "$in":
            for (var f = [], y = [], v = 0, g = n.length; v < g; v++) for (var m = this.calculateRange("$eq", r, n[v]), b = m[0]; b <= m[1]; b++) void 0 === f[b] && (f[b] = !0, y.push(b));

            return y;
        }

        switch (t) {
          case "$eq":
          case "$aeq":
          case "$dteq":
          case "$gte":
          case "$lt":
            o = this.calculateRangeStart(r, n, !1, u), s = e.getIn(l[h[o]], r, u);
        }

        switch (t) {
          case "$eq":
          case "$aeq":
          case "$dteq":
          case "$lte":
          case "$gt":
            a = this.calculateRangeEnd(r, n, u), e.getIn(l[h[a]], r, u);
        }

        switch (t) {
          case "$eq":
          case "$aeq":
          case "$dteq":
            return i.aeq(s, n) ? [o, a] : [0, -1];

          case "$gt":
            return i.aeq(e.getIn(l[h[a]], r, u), n) ? [a + 1, c] : [a, c];

          case "$gte":
            return i.aeq(e.getIn(l[h[o]], r, u), n) ? [o, c] : [o + 1, c];

          case "$lt":
            return i.aeq(e.getIn(l[h[o]], r, u), n) ? [0, o - 1] : [0, o];

          case "$lte":
            return i.aeq(e.getIn(l[h[a]], r, u), n) ? [0, a] : [0, a - 1];

          default:
            return [0, l.length - 1];
        }
      }, k.prototype.by = function (t, e) {
        var i;
        if (void 0 === e) return i = this, function (e) {
          return i.by(t, e);
        };
        var r = this.constraints.unique[t].get(e);
        return this.cloneObjects ? f(r, this.cloneMethod) : r;
      }, k.prototype.findOne = function (t) {
        t = t || {};
        var e = this.chain().find(t, !0).data();
        return Array.isArray(e) && 0 === e.length ? null : this.cloneObjects ? f(e[0], this.cloneMethod) : e[0];
      }, k.prototype.chain = function (t, e) {
        var i = new O(this);
        return void 0 === t ? i : i.transform(t, e);
      }, k.prototype.find = function (t) {
        return this.chain().find(t).data();
      }, k.prototype.findOneUnindexed = function (t, i) {
        for (var r = this.data.length; r--;) if (e.getIn(this.data[r], t, !0) === i) return this.data[r];

        return null;
      }, k.prototype.startTransaction = function () {
        if (this.transactional) {
          this.cachedData = f(this.data, this.cloneMethod), this.cachedIndex = this.idIndex, this.cachedBinaryIndex = this.binaryIndices;

          for (var t = 0; t < this.DynamicViews.length; t++) this.DynamicViews[t].startTransaction();
        }
      }, k.prototype.commit = function () {
        if (this.transactional) {
          this.cachedData = null, this.cachedIndex = null, this.cachedBinaryIndex = null;

          for (var t = 0; t < this.DynamicViews.length; t++) this.DynamicViews[t].commit();
        }
      }, k.prototype.rollback = function () {
        if (this.transactional) {
          null !== this.cachedData && null !== this.cachedIndex && (this.data = this.cachedData, this.idIndex = this.cachedIndex, this.binaryIndices = this.cachedBinaryIndex);

          for (var t = 0; t < this.DynamicViews.length; t++) this.DynamicViews[t].rollback();
        }
      }, k.prototype.async = function (t, e) {
        setTimeout(function () {
          if ("function" != typeof t) throw new TypeError("Argument passed for async execution is not a function");
          t(), e();
        }, 0);
      }, k.prototype.where = function (t) {
        return this.chain().where(t).data();
      }, k.prototype.mapReduce = function (t, e) {
        try {
          return e(this.data.map(t));
        } catch (t) {
          throw t;
        }
      }, k.prototype.eqJoin = function (t, e, i, r, n) {
        return new O(this).eqJoin(t, e, i, r, n);
      }, k.prototype.stages = {}, k.prototype.getStage = function (t) {
        return this.stages[t] || (this.stages[t] = {}), this.stages[t];
      }, k.prototype.commitLog = [], k.prototype.stage = function (t, e) {
        var i = JSON.parse(JSON.stringify(e));
        return this.getStage(t)[e.$loki] = i, i;
      }, k.prototype.commitStage = function (t, e) {
        var i,
            r = this.getStage(t),
            n = new Date().getTime();

        for (i in r) this.update(r[i]), this.commitLog.push({
          timestamp: n,
          message: e,
          data: JSON.parse(JSON.stringify(r[i]))
        });

        this.stages[t] = {};
      }, k.prototype.no_op = function () {}, k.prototype.extract = function (t) {
        for (var e = 0, i = this.data.length, r = D(t), n = []; e < i; e += 1) n.push($(this.data[e], t, r));

        return n;
      }, k.prototype.max = function (t) {
        return Math.max.apply(null, this.extract(t));
      }, k.prototype.min = function (t) {
        return Math.min.apply(null, this.extract(t));
      }, k.prototype.maxRecord = function (t) {
        for (var e, i = 0, r = this.data.length, n = D(t), o = {
          index: 0,
          value: void 0
        }; i < r; i += 1) void 0 !== e ? e < $(this.data[i], t, n) && (e = $(this.data[i], t, n), o.index = this.data[i].$loki) : (e = $(this.data[i], t, n), o.index = this.data[i].$loki);

        return o.value = e, o;
      }, k.prototype.minRecord = function (t) {
        for (var e, i = 0, r = this.data.length, n = D(t), o = {
          index: 0,
          value: void 0
        }; i < r; i += 1) void 0 !== e ? e > $(this.data[i], t, n) && (e = $(this.data[i], t, n), o.index = this.data[i].$loki) : (e = $(this.data[i], t, n), o.index = this.data[i].$loki);

        return o.value = e, o;
      }, k.prototype.extractNumerical = function (t) {
        return this.extract(t).map(S).filter(Number).filter(function (t) {
          return !isNaN(t);
        });
      }, k.prototype.avg = function (t) {
        return C(this.extractNumerical(t));
      }, k.prototype.stdDev = function (t) {
        return e = this.extractNumerical(t), i = C(e), r = C(e.map(function (t) {
          var e = t - i,
              r = e * e;
          return r;
        })), Math.sqrt(r);
        var e, i, r;
      }, k.prototype.mode = function (t) {
        var e,
            i,
            r,
            n = {},
            o = this.extract(t);

        for (i in o.forEach(function (t) {
          n[t] ? n[t] += 1 : n[t] = 1;
        }), n) e ? e < n[i] && (r = i) : (r = i, e = n[i]);

        return r;
      }, k.prototype.median = function (t) {
        var e = this.extractNumerical(t);
        e.sort(A);
        var i = Math.floor(e.length / 2);
        return e.length % 2 ? e[i] : (e[i - 1] + e[i]) / 2;
      }, E.prototype = {
        keys: [],
        values: [],
        sort: function (t, e) {
          return t < e ? -1 : t > e ? 1 : 0;
        },
        setSort: function (t) {
          this.bs = new j(t);
        },
        bs: function () {
          return new j(this.sort);
        },
        set: function (t, e) {
          var i = this.bs(this.keys, t);
          i.found ? this.values[i.index] = e : (this.keys.splice(i.index, 0, t), this.values.splice(i.index, 0, e));
        },
        get: function (t) {
          return this.values[q(this.keys, t, this.sort).index];
        }
      }, N.prototype.keyMap = {}, N.prototype.lokiMap = {}, N.prototype.set = function (t) {
        var e = t[this.field];

        if (null != e) {
          if (this.keyMap[e]) throw new Error("Duplicate key for property " + this.field + ": " + e);
          this.keyMap[e] = t, this.lokiMap[t.$loki] = e;
        }
      }, N.prototype.get = function (t) {
        return this.keyMap[t];
      }, N.prototype.byId = function (t) {
        return this.keyMap[this.lokiMap[t]];
      }, N.prototype.update = function (t, e) {
        if (this.lokiMap[t.$loki] !== e[this.field]) {
          var i = this.lokiMap[t.$loki];
          this.set(e), this.keyMap[i] = void 0;
        } else this.keyMap[t[this.field]] = e;
      }, N.prototype.remove = function (t) {
        var e = this.keyMap[t];
        if (null == e) throw new Error("Key is not in unique index: " + this.field);
        this.keyMap[t] = void 0, this.lokiMap[e.$loki] = void 0;
      }, N.prototype.clear = function () {
        this.keyMap = {}, this.lokiMap = {};
      }, M.prototype = {
        set: function (t, e) {
          this.index[t] ? this.index[t].push(e) : this.index[t] = [e];
        },
        remove: function (t, e) {
          var i = this.index[t];

          for (var r in i) i[r] == e && i.splice(r, 1);

          i.length < 1 && (this.index[t] = void 0);
        },
        get: function (t) {
          return this.index[t];
        },
        clear: function (t) {
          this.index = {};
        }
      }, g.LokiOps = d, g.Collection = k, g.KeyValueStore = E, g.LokiMemoryAdapter = m, g.LokiPartitioningAdapter = b, g.LokiLocalStorageAdapter = I, g.LokiFsAdapter = w, g.persistenceAdapters = {
        fs: w,
        localStorage: I
      }, g.aeq = n, g.lt = s, g.gt = a, g.Comparators = i, g;
    }();
  }),
      a = function () {
    function e() {
      t(this, e), this.queries = {}, this.db = void 0, this.load = this.load.bind(this);
    }

    return i(e, [{
      key: "load",
      value: function () {
        return new Promise(function (t, e) {
          var i = new s.persistenceAdapters.localStorage();
          void 0 !== window.indexedDB && (i = new o("client_analytics")), this.db = new s("games", {
            autosave: !0,
            autosaveInternal: 1e4,
            autoload: !0,
            autoloadCallback: function (i) {
              i ? e(i) : t();
            },
            adapter: i,
            env: "BROWSER"
          }), this.db.addCollection("events");
        }.bind(this));
      }
    }, {
      key: "registerQuery",
      value: function (t, e) {
        return this.queries[t] = e, Promise.resolve();
      }
    }, {
      key: "query",
      value: function (t, e, i) {
        return i = i || "events", Promise.resolve(this.queries[t](this.db.getCollection(i), e));
      }
    }, {
      key: "createCollection",
      value: function (t) {
        if ("events" === t) throw new Error("'events' is a reserved collection name");
        return this.db.addCollection(t), Promise.resolve();
      }
    }, {
      key: "insert",
      value: function (t, e) {
        var i = this.db.getCollection(t);
        if (void 0 === i) throw new Error(t + " is not a collection. Make sure to call createCollection first");
        var r = i.insert(e);
        return Promise.resolve(r);
      }
    }, {
      key: "update",
      value: function (t, e) {
        var i = this.db.getCollection(t);
        if (void 0 === i) throw new Error(t + " is not a collection. Make sure to call createCollection first");
        return i.update(e), Promise.resolve();
      }
    }, {
      key: "remove",
      value: function (t, e) {
        var i = this.db.getCollection(t);
        if (void 0 === i) throw new Error(t + " is not a collection. Make sure to call createCollection first");
        return i.remove(e), Promise.resolve();
      }
    }]), e;
  }(),
      l = function () {
    function e() {
      t(this, e), this.queries = {}, this.bellhop = new window.Bellhop(), this.bellhop.connect();
    }

    return i(e, [{
      key: "load",
      value: function () {
        return Promise.resolve();
      }
    }, {
      key: "registerQuery",
      value: function (t, e) {
        return new Promise(function (i) {
          this.bellhop.fetch("client_analytics_registerQuery", i, {
            name: t,
            code: e.toString()
          });
        }.bind(this));
      }
    }, {
      key: "query",
      value: function (t, e, i) {
        return new Promise(function (r) {
          this.bellhop.fetch("client_analytics_query", function (t) {
            r(t.data);
          }, {
            name: t,
            params: e,
            collectionName: i
          });
        }.bind(this));
      }
    }, {
      key: "createCollection",
      value: function (t) {
        return new Promise(function (e) {
          this.bellhop.fetch("client_analytics_createCollection", e, {
            name: t
          });
        }.bind(this));
      }
    }]), e;
  }();

  l.prototype.insert = function (t, e) {
    return new Promise(function (i) {
      this.bellhop.fetch("client_analytics_insert", i, {
        collectionName: t,
        data: e
      });
    }.bind(this));
  }, l.prototype.update = function (t, e) {
    return new Promise(function (i) {
      this.bellhop.fetch("client_analytics_update", i, {
        collectionName: t,
        data: e
      });
    }.bind(this));
  }, l.prototype.remove = function (t, e) {
    return new Promise(function (i) {
      this.bellhop.fetch("client_analytics_remove", i, {
        collectionName: t,
        data: e
      });
    }.bind(this));
  }, "undefined" != typeof window && (window.PBS = window.PBS || {}, window.PBS.KIDS = window.PBS.KIDS || {}, window.PBS.KIDS.BellhopClientAnalytics = l);

  /**
   * @class BufferedQueue
   * @constructor
   * @param {string} eventServiceUrl The url of the LAP API receiving the events
   * @param {int} batchSize How many events get sent with each POST request
   * @param {int} flushRate How frequently (in ms) the auto-flush function should be called
   */

  var BufferedQueue =
  /*#__PURE__*/
  function () {
    function BufferedQueue(eventServiceUrl) {
      var _this = this;

      var batchSize = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 50;
      var flushRate = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 2000;
      var collectionName = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 'events';

      _classCallCheck(this, BufferedQueue);

      if (eventServiceUrl === undefined) {
        throw new Error('Missing Event Service URL in BufferedQueue constructor. Usage: new BufferedQueue(eventServiceUrl)');
      }

      this.eventServiceUrl = eventServiceUrl;
      this.batchSize = batchSize;
      this.flushRate = flushRate;
      this.collectionName = collectionName;
      /**
       * If we're online
       * @property {boolean} onlineStatus
       */

      this.onlineStatus = true;
      /**
       * Controls whether the buffer is calling its autoflush function
       */

      this.autoFlush = false;
      /**
       * Items waiting in queue
       * Checks if queue already exists in memory, and if not, creates empty array
       * @property {array} queuedItems
       */

      this.queuedItems = [];
      /**
       * Interval object that controls and calls the autoflush function
       */

      this.flushTimer = null;
      /**
       * If we're trying to get events from the database
       * @property {boolean} eventPolling
       */

      this.eventPolling = false;
      /**
       * Interval object that controls and calls the event polling function
       */

      this.pollingTimer = null;
      /**
       * The number of events that have already been sent to the cloud by the LAC
       * Formerly a function of the db data itself, but see: v5.5.0
       */

      this.sentEventCount = localStorage.getItem('lacSentEventCount') ? parseInt(localStorage.getItem('lacSentEventCount')) : 0; // before window closes, make sure to destroy (calls saveToStorage)

      window.addEventListener('beforeunload', function () {
        _this.destroyQueue();
      });
      /**
       * Client analytics database instance that holds event data when not in the queue
       */

      this.storageDb = new a(); // Initialize the database with our collection, two queries, and pull items that were queued but unsent

      this.ready = this.storageDb.load().then(function () {
        // check if collection specified exists, if not, create it
        var collection = _this.storageDb.db.getCollection(_this.collectionName);

        if (collection === undefined || collection === null) {
          _this.storageDb.createCollection(collectionName);
        } // pulls actual event data from db


        _this.storageDb.registerQuery('get_events', function (collection, params) {
          // split for whether or not you want to get a limited number of events
          if (params.limit) {
            return collection.chain().find({
              queueStatus: params.status
            }).limit(params.limit).simplesort('timestamp', false).data();
          } else {
            // getting all events of a particular type
            if (params.status) {
              return collection.chain().find({
                queueStatus: params.status
              }).simplesort('timestamp', false).data();
            } // getting all events in the database, period.
            else {
                return collection.chain().find(true).simplesort('timestamp', false).data();
              }
          }
        }); // gets just a count of the number of events with that status


        _this.storageDb.registerQuery('get_count', function (collection, params) {
          // count all events
          if (params.status === 'A') {
            return collection.find(true).length;
          } else {
            return collection.find({
              queueStatus: params.status
            }).length;
          }
        });
      }) // place 'in-queue' events back in the queue
      .then(function () {
        return _this.storageDb.query('get_events', {
          status: 'Q',
          limit: false
        }, _this.collectionName);
      }).then(function (oldQueue) {
        _this.queuedItems = oldQueue;
        return _this;
      });
    }
    /**
     * Wrapper for determining if queue has objects in it
     */


    _createClass(BufferedQueue, [{
      key: "isEmpty",
      value: function isEmpty() {
        if (this.queuedItems.length > 0) {
          return false;
        } else {
          return true;
        }
      }
      /**
       * Turn on the automatic getting of events from the database
       */

    }, {
      key: "enableEventPolling",
      value: function enableEventPolling() {
        this.eventPolling = true;
        this.pollingTimer = setInterval(this.populateQueue.bind(this), this.flushRate * 2);
      }
      /**
       * Turn off the automatic getting of events from the database
       */

    }, {
      key: "disableEventPolling",
      value: function disableEventPolling() {
        if (this.eventPolling) {
          this.eventPolling = false;
        }

        if (this.pollingTimer !== null) {
          clearInterval(this.pollingTimer);
          this.pollingTimer = null;
        }
      }
      /**
       * Stores event in backend database
       */

    }, {
      key: "storeEvent",
      value: function storeEvent(eventData) {
        var _this2 = this;

        return this.runGarabageCollector().then(function () {
          eventData.queueStatus = 'U';
          return _this2.storageDb.insert(_this2.collectionName, eventData);
        });
      }
      /**
       * Removes event in backend database
       */

    }, {
      key: "deleteEvent",
      value: function deleteEvent(eventData) {
        return this.storageDb.remove(this.collectionName, eventData);
      }
      /**
       * In order to prevent the db from taking up too much memory,
       * on each insert, run a garbage collector to delete the oldest
       * sent events first, then old failed, then old unsent if no other choice.
       */

    }, {
      key: "runGarabageCollector",
      value: function runGarabageCollector() {
        var _this3 = this;

        return this.getAllEventsCount().then(function (count) {
          var toBeDeleted = false;

          var collection = _this3.storageDb.db.getCollection(_this3.collectionName);

          if (count > 200000) {
            // Get oldest failed event
            toBeDeleted = _this3.getEventForDeletion(collection, 'F'); // if no sent or failed events, get oldest unsent event

            if (!toBeDeleted[0]) {
              toBeDeleted = _this3.getEventForDeletion(collection, 'U');
            }

            return _this3.deleteEvent(toBeDeleted[0]);
          } else {
            return Promise.resolve();
          }
        });
      }
      /**
       * Performs a search on the collection for the oldest item with the selected status
       * @param {Collection} collection The collection object that is being deleted from
       * @param {String} incomingStatus The status code being looked for
       */

    }, {
      key: "getEventForDeletion",
      value: function getEventForDeletion(collection, incomingStatus) {
        return collection.chain().find({
          queueStatus: incomingStatus
        }).simplesort('timestamp', false).limit(1).data();
      }
      /**
       * Generic queue status modifier function
       */

    }, {
      key: "markEventStatus",
      value: function markEventStatus(eventData, newStatus) {
        eventData.queueStatus = newStatus;
        return this.storageDb.update(this.collectionName, eventData);
      }
      /**
       * Put BATCH_SIZE * 2 events into the queue from the database, unsent > failed
       */

    }, {
      key: "populateQueue",
      value: function populateQueue() {
        var _this4 = this;

        return this.getEventsByStatus('U').then(function (events) {
          if (events.length === 0) {
            return _this4.getEventsByStatus('F');
          } else {
            return events;
          }
        }).then(function (events) {
          if (events.length !== 0) {
            events.forEach(function (event) {
              _this4.markEventStatus(event, 'Q');

              _this4.enqueueEvent(event);
            });
          }
        });
      }
      /**
       * Better reading wrapper for the db query
       */

    }, {
      key: "getEventsByStatus",
      value: function getEventsByStatus(incomingStatus) {
        return this.storageDb.query('get_events', {
          status: incomingStatus,
          limit: this.batchSize * 2
        }, this.collectionName);
      }
      /**
       * Better reading wrapper for the db query
       */

    }, {
      key: "getNumEventsByStatus",
      value: function getNumEventsByStatus(incomingStatus) {
        return this.storageDb.query('get_count', {
          status: incomingStatus,
          limit: false
        }, this.collectionName);
      }
      /**
       * Property wrappers for number of event getters
       */

    }, {
      key: "getAllEventsCount",
      value: function () {
        var _getAllEventsCount = _asyncToGenerator(
        /*#__PURE__*/
        regenerator.mark(function _callee() {
          var localEventCount;
          return regenerator.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return this.getNumEventsByStatus('A');

                case 2:
                  localEventCount = _context.sent;
                  return _context.abrupt("return", Promise.resolve(localEventCount + this.sentEventCount));

                case 4:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function getAllEventsCount() {
          return _getAllEventsCount.apply(this, arguments);
        }

        return getAllEventsCount;
      }()
    }, {
      key: "getSecondsToEmptyDb",
      value: function getSecondsToEmptyDb() {
        var _this5 = this;

        var unsentCount = this.unsentEventCount;
        var queuedCount = this.queuedEventCount;
        return Promise.all([unsentCount, queuedCount]).then(function (results) {
          var total = results[0] + results[1];
          return total / _this5.batchSize * (_this5.flushRate / 1000);
        });
      }
      /**
       * Add an event data object to queue
       * @param {object} eventData
       */

    }, {
      key: "enqueueEvent",
      value: function enqueueEvent(eventData) {
        this.queuedItems.push(eventData);
      }
      /**
       * Remove the next event data object from the queue
       */

    }, {
      key: "dequeueEvent",
      value: function dequeueEvent(newStatus) {
        if (!this.isEmpty()) {
          var poppedEvent = this.queuedItems.shift();
          return this.markEventStatus(poppedEvent, newStatus).then(function () {
            return poppedEvent;
          });
        } else {
          return false;
        }
      }
      /**
       * Sends event data to the API
       * @param {Array} batchOfEvents Event data to send
       */

    }, {
      key: "sendBatchToApi",
      value: function sendBatchToApi(batchOfEvents) {
        if (batchOfEvents.length > 0) {
          // need this b/c `this` will be different inside request object
          var queueLink = this;
          var request = new XMLHttpRequest();
          request.onload =
          /*#__PURE__*/
          _asyncToGenerator(
          /*#__PURE__*/
          regenerator.mark(function _callee2() {
            var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step;

            return regenerator.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    _iteratorNormalCompletion = true;
                    _didIteratorError = false;
                    _iteratorError = undefined;
                    _context2.prev = 3;
                    _iterator = batchOfEvents[Symbol.iterator]();

                  case 5:
                    if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                      _context2.next = 13;
                      break;
                    }

                    event = _step.value;
                    queueLink.sentEventCount += 1;
                    _context2.next = 10;
                    return queueLink.deleteEvent(event);

                  case 10:
                    _iteratorNormalCompletion = true;
                    _context2.next = 5;
                    break;

                  case 13:
                    _context2.next = 19;
                    break;

                  case 15:
                    _context2.prev = 15;
                    _context2.t0 = _context2["catch"](3);
                    _didIteratorError = true;
                    _iteratorError = _context2.t0;

                  case 19:
                    _context2.prev = 19;
                    _context2.prev = 20;

                    if (!_iteratorNormalCompletion && _iterator.return != null) {
                      _iterator.return();
                    }

                  case 22:
                    _context2.prev = 22;

                    if (!_didIteratorError) {
                      _context2.next = 25;
                      break;
                    }

                    throw _iteratorError;

                  case 25:
                    return _context2.finish(22);

                  case 26:
                    return _context2.finish(19);

                  case 27:
                  case "end":
                    return _context2.stop();
                }
              }
            }, _callee2, this, [[3, 15, 19, 27], [20,, 22, 26]]);
          }));

          request.onerror =
          /*#__PURE__*/
          function () {
            var _ref2 = _asyncToGenerator(
            /*#__PURE__*/
            regenerator.mark(function _callee3(e) {
              var _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2;

              return regenerator.wrap(function _callee3$(_context3) {
                while (1) {
                  switch (_context3.prev = _context3.next) {
                    case 0:
                      _iteratorNormalCompletion2 = true;
                      _didIteratorError2 = false;
                      _iteratorError2 = undefined;
                      _context3.prev = 3;
                      _iterator2 = batchOfEvents[Symbol.iterator]();

                    case 5:
                      if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                        _context3.next = 17;
                        break;
                      }

                      event = _step2.value;

                      if (!(this.status === 422)) {
                        _context3.next = 13;
                        break;
                      }

                      queueLink.sentEventCount += 1; // event was not validated, but was saved, so still delete

                      _context3.next = 11;
                      return queueLink.deleteEvent(event);

                    case 11:
                      _context3.next = 14;
                      break;

                    case 13:
                      // event is marked as failed for later attempts at sending
                      queueLink.markEventStatus(event, 'F');

                    case 14:
                      _iteratorNormalCompletion2 = true;
                      _context3.next = 5;
                      break;

                    case 17:
                      _context3.next = 23;
                      break;

                    case 19:
                      _context3.prev = 19;
                      _context3.t0 = _context3["catch"](3);
                      _didIteratorError2 = true;
                      _iteratorError2 = _context3.t0;

                    case 23:
                      _context3.prev = 23;
                      _context3.prev = 24;

                      if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
                        _iterator2.return();
                      }

                    case 26:
                      _context3.prev = 26;

                      if (!_didIteratorError2) {
                        _context3.next = 29;
                        break;
                      }

                      throw _iteratorError2;

                    case 29:
                      return _context3.finish(26);

                    case 30:
                      return _context3.finish(23);

                    case 31:
                    case "end":
                      return _context3.stop();
                  }
                }
              }, _callee3, this, [[3, 19, 23, 31], [24,, 26, 30]]);
            }));

            return function (_x) {
              return _ref2.apply(this, arguments);
            };
          }(); // mapping events to a copy so we can remove the loki metadata from the payload without screwing up the database


          var payload = batchOfEvents.map(function (event) {
            var copy = Object.assign({}, event);
            delete copy.meta;
            delete copy.$loki;
            delete copy.queueStatus;
            return copy;
          });
          request.open('POST', this.eventServiceUrl);
          request.setRequestHeader('Content-Type', 'application/json');
          request.send(JSON.stringify(payload));
        }
      }
      /**
       * Creates an array of events from the queue, with the number controlled by batchSize
       */

    }, {
      key: "createBatch",
      value: function createBatch() {
        var batch = [];

        for (var i = 0; i < this.batchSize; i++) {
          if (!this.isEmpty()) {
            batch.push(this.dequeueEvent('INFLIGHT'));
          } else {
            continue;
          }
        }

        return Promise.all(batch);
      }
      /**
       * Sets the onlineStatus variable and turns on polling
       * @param {boolean} onlineStatus
       */

    }, {
      key: "setOnline",
      value: function setOnline(onlineStatus) {
        this.onlineStatus = onlineStatus; // if turning from offline to online, begin polling for events from db and sending up to cloud

        if (onlineStatus) {
          this.enableEventPolling();
          this.enableAutoFlush();
        } // and the inverse
        else {
            this.disableEventPolling();
            this.disableAutoFlush();
          }
      }
      /**
       * Turns off autoflush and destroys the repeater
       */

    }, {
      key: "disableAutoFlush",
      value: function disableAutoFlush() {
        if (this.autoFlush) {
          this.autoFlush = false;
        }

        if (this.flushTimer !== null) {
          clearInterval(this.flushTimer);
          this.flushTimer = null;
        }
      }
      /**
       * Turns on autoflush and creates a repeater
       */

    }, {
      key: "enableAutoFlush",
      value: function enableAutoFlush() {
        this.autoFlush = true;
        this.flushTimer = setInterval(this.flushBatch.bind(this), this.flushRate);
      }
      /**
       * Sends one batch of data to the API, if the plugin is online
       */

    }, {
      key: "flushBatch",
      value: function flushBatch() {
        var _this6 = this;

        // dont want to try to flush if offline
        if (this.onlineStatus) {
          return this.createBatch().then(function (batchOfEvents) {
            return _this6.sendBatchToApi(batchOfEvents);
          });
        } else {
          return Promise.resolve();
        }
      }
      /**
       * Calls the flushBatch function until the queue is empty
       */

    }, {
      key: "flushAll",
      value: function () {
        var _flushAll = _asyncToGenerator(
        /*#__PURE__*/
        regenerator.mark(function _callee4() {
          return regenerator.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  if (this.onlineStatus) {
                    _context4.next = 2;
                    break;
                  }

                  return _context4.abrupt("return", Promise.resolve());

                case 2:
                  if (this.isEmpty()) {
                    _context4.next = 7;
                    break;
                  }

                  _context4.next = 5;
                  return this.flushBatch();

                case 5:
                  _context4.next = 2;
                  break;

                case 7:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4, this);
        }));

        function flushAll() {
          return _flushAll.apply(this, arguments);
        }

        return flushAll;
      }()
      /**
       * Just empties out the queue
       */

    }, {
      key: "clearQueue",
      value: function () {
        var _clearQueue = _asyncToGenerator(
        /*#__PURE__*/
        regenerator.mark(function _callee5() {
          return regenerator.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  if (this.isEmpty()) {
                    _context5.next = 5;
                    break;
                  }

                  _context5.next = 3;
                  return this.dequeueEvent('U');

                case 3:
                  _context5.next = 0;
                  break;

                case 5:
                  return _context5.abrupt("return", Promise.resolve());

                case 6:
                case "end":
                  return _context5.stop();
              }
            }
          }, _callee5, this);
        }));

        function clearQueue() {
          return _clearQueue.apply(this, arguments);
        }

        return clearQueue;
      }()
      /**
       * Destroys the queue object so it is not active anymore
       */

    }, {
      key: "destroyQueue",
      value: function () {
        var _destroyQueue = _asyncToGenerator(
        /*#__PURE__*/
        regenerator.mark(function _callee6() {
          return regenerator.wrap(function _callee6$(_context6) {
            while (1) {
              switch (_context6.prev = _context6.next) {
                case 0:
                  localStorage.setItem('lacSentEventCount', this.sentEventCount);
                  _context6.next = 3;
                  return this.clearQueue();

                case 3:
                  this.disableAutoFlush();

                case 4:
                case "end":
                  return _context6.stop();
              }
            }
          }, _callee6, this);
        }));

        function destroyQueue() {
          return _destroyQueue.apply(this, arguments);
        }

        return destroyQueue;
      }()
    }, {
      key: "unsentEventCount",
      get: function get() {
        return this.getNumEventsByStatus('U');
      }
    }, {
      key: "failedEventCount",
      get: function get() {
        return this.getNumEventsByStatus('F');
      }
    }, {
      key: "queuedEventCount",
      get: function get() {
        return this.getNumEventsByStatus('Q');
      }
    }]);

    return BufferedQueue;
  }();

  /**
   * Utility class for detecting platform.
   * @class Platform
   */
  var Platform = function Platform() {
    _classCallCheck(this, Platform);

    /**
     * The name of the browser
     * @property {string} browser
     */
    this.browser = this.searchString(BROWSERS) || 'unknown browser';
    /**
     * The version of the user agent or app
     * @property {string} version
     */

    this.version = this.searchVersion(navigator.userAgent) || this.searchVersion(navigator.appVersion) || 'unknown version';
    /**
     * The version search string
     * @property {string} versionSearchString
     * @private
     */

    this.versionSearchString = null;
    /**
     * The current verison of the operating system
     * @property {string} OS
     */

    this.OS = this.searchString(OSES) || 'unknown OS';
  }; // reference to the prototype
  var p = Platform.prototype;
  /**
   * Simple detector to find unsupported browser features
   * @return {Array} Array of unsupported browser description strings
   */

  function _unsupportedFeatures() {
    var missing = []; // check if promises are available

    if (window.Promise === undefined || window.Promise === null || window.Promise === false) {
      missing.push('promises');
    }

    return missing;
  }
  /**
   * Detect if the browser platform is Internet Explorer 11
   * @return {Boolean} Is this IE 11?
   */


  p.isIE11 = function () {
    var _is11 = false;

    var unsupported = _unsupportedFeatures();

    if (unsupported.indexOf('promises') !== -1) {
      _is11 = true;
    }

    return _is11;
  };
  /**
   * Search a string
   * @method searchString
   * @param {string|Array} data The collection of dat ato search
   * @return {null|String} The result or null
   */


  p.searchString = function (data) {
    for (var i = 0; i < data.length; i++) {
      var dataString = data[i].string;
      var dataProp = data[i].prop;
      this.versionSearchString = data[i].versionSearch || data[i].identity;

      if (dataString) {
        if (dataString.indexOf(data[i].subString) != -1) {
          return data[i].identity;
        }
      } else if (dataProp) {
        return data[i].identity;
      }
    }
  };
  /**
   *  Get the version for a string
   *  @method searchVersion
   *  @param {string} dataString The version to search for
   *  @return {null|number} The version number
   */


  p.searchVersion = function (dataString) {
    var index = dataString.indexOf(this.versionSearchString);
    if (index == -1) return;
    return parseFloat(dataString.substring(index + this.versionSearchString.length + 1));
  };
  /**
   *  The collection of BROWSERS types
   *  @property {array} BROWSERS
   *  @static
   *  @readOnly
   *  @private
   */


  var BROWSERS = [{
    string: navigator.userAgent,
    subString: 'Chrome',
    identity: 'Chrome'
  }, {
    string: navigator.userAgent,
    subString: 'OmniWeb',
    versionSearch: 'OmniWeb/',
    identity: 'OmniWeb'
  }, {
    string: navigator.vendor,
    subString: 'Apple',
    identity: 'Safari',
    versionSearch: 'Version'
  }, {
    prop: window.opera,
    identity: 'Opera',
    versionSearch: 'Version'
  }, {
    string: navigator.vendor,
    subString: 'iCab',
    identity: 'iCab'
  }, {
    string: navigator.vendor,
    subString: 'KDE',
    identity: 'Konqueror'
  }, {
    string: navigator.userAgent,
    subString: 'Firefox',
    identity: 'Firefox'
  }, {
    string: navigator.vendor,
    subString: 'Camino',
    identity: 'Camino'
  }, {
    // for newer Netscapes (6+)
    string: navigator.userAgent,
    subString: 'Netscape',
    identity: 'Netscape'
  }, {
    string: navigator.userAgent,
    subString: 'MSIE',
    identity: 'Explorer',
    versionSearch: 'MSIE'
  }, {
    string: navigator.userAgent,
    subString: 'Gecko',
    identity: 'Mozilla',
    versionSearch: 'rv'
  }, {
    // for older Netscapes (4-)
    string: navigator.userAgent,
    subString: 'Mozilla',
    identity: 'Netscape',
    versionSearch: 'Mozilla'
  }];
  /**
   *  The collection of OS types
   *  @property {array} OSES
   *  @static
   *  @readOnly
   *  @private
   */

  var OSES = [{
    string: navigator.platform,
    subString: 'Win',
    identity: 'WindowsPC'
  }, {
    string: navigator.platform,
    subString: 'Mac',
    identity: 'Mac'
  }, {
    string: navigator.userAgent,
    subString: 'iPhone',
    identity: 'iPhone/iPod'
  }, {
    string: navigator.userAgent,
    subString: 'iPad',
    identity: 'iPad'
  }, {
    string: navigator.userAgent,
    subString: 'Android',
    identity: 'Android'
  }, {
    string: navigator.platform,
    subString: 'Linux',
    identity: 'LinuxPC'
  }, {
    string: navigator.userAgent,
    subString: 'apple-phone-audio-bug',
    identity: 'iPhone/iPod'
  }, {
    string: navigator.userAgent,
    subString: 'apple-tablet-audio-bug',
    identity: 'iPad'
  }];

  /**
   *  The collection name used for storing event data locally
   *  @property {string} COLLECTION_NAME
   *  @private
   *  @static
   *  @readOnly
   */

  var COLLECTION_NAME = 'events';
  /**
   *  The time (in ms) between queue flushes
   *  @property {string} FLUSH_RATE
   *  @private
   *  @default 2000
   *  @static
   *  @readOnly
   */

  var FLUSH_RATE = 2000;
  /**
   *  The batch size of the queue
   *  @property {int} BATCH_SIZE
   *  @private
   *  @default 50
   *  @static
   *  @readOnly
   */

  var BATCH_SIZE = 50;
  /**
   *  JSON object keys for validation
   *  @property {object} EVENT_KEYS
   *  @private
   *  @static
   *  @readOnly
   */

  var EVENT_KEYS = {
    v2: {
      game: ['timestamp', 'user_ids', 'game_id', 'device_id', 'platform_id', 'event_id', 'event_data', 'game_session'],
      video: ['timestamp', 'user_ids', 'video_id', 'device_id', 'platform_id', 'event_id', 'event_data', 'video_session']
    },
    v1: ['timestamp', 'user_ids', 'game_id', 'device_id', 'platform_id', 'event_id', 'event_data', 'game_session']
  };
  var Identity;
  /**
   * A module that consumers can use to expose Super Vision kid labels to this plugin. Basically, the
   * "PBS.KIDS.CurrentKidLabel" (if it exists), should be an object with a get and set method to allow "setters" to
   * update the value on the fly, so that this plugin can always get the latest value when needed
   *
   * @var {Object} CurrentKidLabel
   */

  var CurrentKidLabel;
  /**
   * A module that consumers can use to expose the Super Vision channel id to this plugin. Basically, the
   * "PBS.KIDS.CurrentChannelId" (if it exists), should be an object witha get and set method to allow "setters" to
   * update the value on the fly, so that this plugin can always get the latest value when needed
   *
   * @var {Object} CurrentChannelId
   */

  var CurrentChannelId;
  /**
   * A module that consumers can use to expose the a content origin to this plugin. Basically, the
   * "PBS.KIDS.ContentOrigin" (if it exists), should be an object with a get and set method to allow "setters" to
   * update the value on the fly, so that this plugin can always get the latest value when needed. For instance, a value
   * might look like "org.pbskids.measureup", or "org.pbskids.gamesapp" to distinguish *where* the event came from. As
   * more Springroll games get embedded in multiple places, this will be valuable when wanting to filter those events
   * based on *where* the game was played (Measure Up vs. pbskids.org vs. Games vs. whatever)
   *
   * @var {Object} ContentOrigin
   */

  var ContentOrigin;
  /**
   * A module that consumers can use to expose a unique id for the installation of this app/game on a particular
   * device. Moving forward, Trampoline will provide this feature via Trampoline.util.getInstallationId(). However,
   * implementors can simply provide a global PBS.KIDS.InstallationId with a get method defined and this plugin should
   * pick it up and attach it to the event.
   */

  var InstallationId;
  /**
   * A module that consumers can use to expose the current study that the game is participating in. Implementors will
   * need this to be an object with a `get` method.
   */

  var StudyId;
  /**
   * A module that consumers can use to expose the current participant's id that's playing the game. Useful for studies.
   * Developers need to expose a global PBS.KIDS.ParticipantId.get() function that returns that value.
   */

  var ParticipantId;
  /**
   * Handle the Learning Analytics events
   * @class AnalyticsReporter
   * @constructor
   * @param {string} learningApiUrl The url for the LAP event collector end-point in the cloud
   */

  var AnalyticsReporter =
  /*#__PURE__*/
  function (_EventDispatcher) {
    _inherits(AnalyticsReporter, _EventDispatcher);

    function AnalyticsReporter(learningApiUrl) {
      var _this;

      _classCallCheck(this, AnalyticsReporter);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(AnalyticsReporter).call(this));
      var pbskids = {};

      if (window.PBS && window.PBS.KIDS) {
        pbskids = window.PBS.KIDS;
      }

      if (!learningApiUrl || learningApiUrl === '') {
        throw Error('learningApiUrl not set in AnalyticsReporter constructor. ' + 'Check the container options, and the constructor in the AnalyticsReporterPlugin setup() method.');
      }

      Identity = pbskids.identity;
      CurrentKidLabel = pbskids.CurrentKidLabel;
      CurrentChannelId = pbskids.CurrentChannelId;
      ContentOrigin = pbskids.ContentOrigin;
      InstallationId = pbskids.InstallationId;
      StudyId = pbskids.StudyId;
      ParticipantId = pbskids.ParticipantId;
      /**
       * The valid event keys for the resource type
       * @property {array} eventKeys
       * @private
       */

      _this.eventKeys = EVENT_KEYS.v1;
      /**
       * The API endpoint for reporting events
       * @property {string} learningApiUrl
       * @private
       */

      _this.learningApiUrl = learningApiUrl;
      /**
       * The BufferedQueue object that saves and sends events
       * @property {BufferedQueue} queue
       * @private
       */

      _this.queue = new BufferedQueue(_this.learningApiUrl, BATCH_SIZE, FLUSH_RATE, COLLECTION_NAME);
      setTimeout(function () {
        return _this.setupPlatform();
      }, 1);
      /**
       * The setInterval ping to check online status
       * @property {int} _timer
       * @private
       */

      _this._timer = null;
      /**
       * Internal enabled boolean
       * @property {Boolean} _enabled
       * @private
       * @default true
       */

      _this._enabled = false; // binding the current instance's status check so it can be removed from listeners in the destroy method

      _this.checkStatus = _this.checkStatus.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      window.addEventListener('offline', _this.checkStatus);
      return _this;
    }

    _createClass(AnalyticsReporter, [{
      key: "setupPlatform",
      value: function setupPlatform() {
        var beforeResolvePlatformResult = this.trigger('beforeResolvePlatform');

        if (!beforeResolvePlatformResult.defaultPrevented) {
          var platform = new Platform();
          var afterResolvePlatformResult = this.trigger('afterResolvePlatform', {
            platform: platform
          });
          /**
           * For getting platform details
           * @property {PBS.KIDS.Platform} platform
           */

          this.platform = afterResolvePlatformResult.platform;
        }
      }
      /**
       * If the queueing should autoflush
       * @param {boolean} autoFlush Whether or not to enable auto flush for the queue
       * @return {void}
       */

    }, {
      key: "setAutoFlush",
      value: function setAutoFlush(autoFlush) {
        var beforeSetAutoFlushResult = this.trigger('beforeSetAutoFlush', {
          autoFlush: autoFlush
        });

        if (beforeSetAutoFlushResult.defaultPrevented) {
          return;
        }

        if (beforeSetAutoFlushResult.autoFlush) {
          this.queue.enableAutoFlush();
        } else {
          this.queue.disableAutoFlush();
        }

        this.trigger('afterSetAutoFlush', {
          autoFlush: beforeSetAutoFlushResult.autoFlush
        });
      }
      /**
       * Check the online status internally on a timer
       * Auto calling function to keep updating online staus
       * @method checkStatus
       * @private
       * @return {Promise<void>} A promise that resolves when online status has been determined
       */

    }, {
      key: "checkStatus",
      value: function () {
        var _checkStatus = _asyncToGenerator(
        /*#__PURE__*/
        regenerator.mark(function _callee() {
          var beforeCheckOnlineStatusResult, onlineStatus;
          return regenerator.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (this.enabled) {
                    _context.next = 2;
                    break;
                  }

                  return _context.abrupt("return");

                case 2:
                  beforeCheckOnlineStatusResult = this.trigger('beforeCheckOnlineStatus');

                  if (!beforeCheckOnlineStatusResult.defaultPrevented) {
                    _context.next = 5;
                    break;
                  }

                  return _context.abrupt("return");

                case 5:
                  _context.next = 7;
                  return isOnline();

                case 7:
                  onlineStatus = _context.sent;
                  this.queue.setOnline(onlineStatus);
                  this.trigger('afterCheckOnlineStatus', {
                    onlineStatus: onlineStatus
                  });

                case 10:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function checkStatus() {
          return _checkStatus.apply(this, arguments);
        }

        return checkStatus;
      }()
      /**
       * Flush the queue
       * @method flushAll
       * @return {void}
       */

    }, {
      key: "flushAll",
      value: function () {
        var _flushAll = _asyncToGenerator(
        /*#__PURE__*/
        regenerator.mark(function _callee2() {
          var beforeFlushAllResult;
          return regenerator.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  beforeFlushAllResult = this.trigger('beforeFlushAll');

                  if (!beforeFlushAllResult.defaultPrevented) {
                    _context2.next = 3;
                    break;
                  }

                  return _context2.abrupt("return");

                case 3:
                  _context2.next = 5;
                  return this.queue.flushAll();

                case 5:
                  this.trigger('afterFlushAll');

                case 6:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        function flushAll() {
          return _flushAll.apply(this, arguments);
        }

        return flushAll;
      }()
      /**
       * Whether or not tracking is enabled
       * @property {boolean} enabled
       * @default false
       * @return {boolean} Whether or not the reporter is enabled
       */

    }, {
      key: "appendPlatformDetails",

      /**
       * Insert platform in JSON Data
       * @method appendPlatformDetails
       * @private
       * @param {object} eventData The event object data
       * @return {AnalyticsReporter} Instance for chaining
       */
      value: function appendPlatformDetails(eventData) {
        eventData.platform_id = this.platform.browser;
        eventData.device_id = this.platform.OS;
        return this;
      }
      /**
       * Insert user information in JSON Data
       * @method appendUserData
       * @private
       * @param {object} eventData The event object data
       * @return {AnalyticsReporter} Instance for chaining
       */

    }, {
      key: "appendUserData",
      value: function appendUserData(eventData) {
        if (Identity) {
          eventData.user_ids = [];
          var users = Identity.getCurrentUsers();

          for (var i = 0; i < users.length; i++) {
            if (users[i].userid) {
              eventData.user_ids.push(users[i].userid);
            }

            eventData.is_logged_in = users[i].isloggedin;
          }

          eventData.identities = Identity.getAllIdentities();
        } // If clients have defined a "PBS.KIDS.CurrentKidLabel" module, we'll also include the kid label there as well


        if (CurrentKidLabel instanceof Object) {
          eventData.kid_label_guid = CurrentKidLabel.get();
        }

        return this;
      }
      /**
       * Adds the current super vision channel id to the event JSON data
       * @method appendChannelId
       * @private
       * @param {object} eventData The event object data
       * @return {AnalyticsReporter} Instance for chaining
       */

    }, {
      key: "appendChannelId",
      value: function appendChannelId(eventData) {
        // If clients have defined a "PBS.KIDS.CurrentChannelId" module, we'll also include the channel id as well
        if (CurrentChannelId instanceof Object) {
          eventData.channel_id = CurrentChannelId.get();
        }

        return this;
      }
      /**
       * Adds the installation id for this app and device onto the event's JSON data, if the module is defined
       * @method appendInstallationId
       * @private
       * @param {object} eventData The event object data
       * @return {AnalyticsReporter} Instance for chaining
       */

    }, {
      key: "appendInstallationId",
      value: function appendInstallationId(eventData) {
        if (InstallationId instanceof Object) {
          eventData.installation_id = InstallationId.get();
        }

        return this;
      }
      /**
       * Adds the currently configured study for this app, if the module is exposed AND there is a configured study
       * @method appendStudyId
       * @private
       * @param {object} eventData The event object data
       * @return {AnalyticsReporter} Instance for chaining
       */

    }, {
      key: "appendStudyId",
      value: function appendStudyId(eventData) {
        if (StudyId instanceof Object && StudyId.get() !== null) {
          eventData.study_id = StudyId.get();
        }

        return this;
      }
    }, {
      key: "appendParticipantId",
      value: function appendParticipantId(eventData) {
        if (ParticipantId instanceof Object && ParticipantId.get() !== null) {
          eventData.participant_id = ParticipantId.get();
        }

        return this;
      }
      /**
       * Adds the current Super Vision content origin to the event JSON data
       * @method appendContentOrigin
       * @private
       * @param {Object} eventData The event object data
       * @return {AnalyticsReporter} Instance for chaining
       */

    }, {
      key: "appendContentOrigin",
      value: function appendContentOrigin(eventData) {
        // If clients have defined a content origin, we'll attach it
        if (ContentOrigin instanceof Object) {
          eventData.content_origin = ContentOrigin.get();
        }

        return this;
      }
      /**
       * Add the timestamp to the event JSON data
       * @method appendTimeStamp
       * @private
       * @param {object} eventData The event object data
       * @return {AnalyticsReporter} Instance for chaining
       */

    }, {
      key: "appendTimeStamp",
      value: function appendTimeStamp(eventData) {
        if (eventData.timestamp === undefined) {
          eventData.timestamp = Date.now();
        }

        return this;
      }
      /**
       * Push a learning event
       * @method pushEvent
       * @param {object} eventData The event object data
       * @param {string} eventData.game_id The GUID for the game
       * @param {string} eventData.event_id The GUID for the event
       * @param {object} eventData.event_data The data for event
       * @return {object} The event data with any appended data
       */

    }, {
      key: "pushEvent",
      value: function pushEvent(eventData) {
        // Ignore if we aren't enabled
        if (!this._enabled) {
          return this;
        }

        if (eventData.user_ids === undefined) {
          eventData.user_ids = [];
        }

        eventData.is_logged_in = false;
        this.appendTimeStamp(eventData).appendPlatformDetails(eventData).appendUserData(eventData).appendChannelId(eventData).appendInstallationId(eventData).appendStudyId(eventData).appendParticipantId(eventData).appendContentOrigin(eventData);

        if (!this.validateEvent(eventData)) {
          return eventData;
        } // clone the event so that our extra methods and flags we add in the dispatcher don't accidentally get stored


        var beforePushEventResult = this.trigger('beforePushEvent', Object.assign({}, eventData));

        if (beforePushEventResult.defaultPrevented) {
          return eventData;
        } // strip the event extra data and pass the modified object to store event, which will give listeners a chance to
        // modify the event before it's stored


        var event = this.stripEventMetadata(beforePushEventResult);
        this.queue.storeEvent(event);
        this.trigger('afterPushEvent', Object.assign({}, event));
        return event;
      }
      /**
       * Validate Event JSON data
       * @method validateEvent
       * @param {object} eventData The raw event data to validate
       * @private
       * @return {Boolean} if the event is valid
       */

    }, {
      key: "validateEvent",
      value: function validateEvent(eventData) {
        var beforeValidateEventResult = this.trigger('beforeValidateEvent', {
          eventData: eventData
        });

        if (beforeValidateEventResult.defaultPrevented) {
          return true;
        }

        var isValid = true;
        var invalidKeys = [];

        for (var i = 0; i < this.eventKeys.length; i++) {
          var value = eventData[this.eventKeys[i]];

          if (value === null || value === undefined || value === '') {
            isValid = false;
            invalidKeys.push(this.eventKeys[i]);
          }
        }

        var afterValidateEventResult = this.trigger('afterValidateEvent', {
          eventData: eventData,
          isValid: isValid,
          invalidKeys: invalidKeys
        });
        return afterValidateEventResult.isValid;
      }
      /**
       * Cleanup and don't use after this
       * @method destroy
       * @return {void}
       */

    }, {
      key: "destroy",
      value: function destroy() {
        var beforeDestroyResult = this.trigger('beforeDestroy');

        if (beforeDestroyResult.defaultPrevented) {
          return;
        }

        this.enabled = false;
        this.queue.destroyQueue();
        window.removeEventListener('offline', this.checkStatus);
        this.trigger('afterDestroy');
      }
    }, {
      key: "enabled",
      get: function get() {
        return this._enabled;
      }
      /**
       * Enable or disable tracking
       * @property {boolean} enabled
       * @param {Boolean} value True to enable the reporter, false to disable it
       * @default
       */
      ,
      set: function set(value) {
        var beforeSetEnabledResult = this.trigger('beforeSetEnabled', {
          enabled: value
        });

        if (beforeSetEnabledResult.defaultPrevented) {
          return;
        }

        this._enabled = value;

        if (this._timer) {
          clearInterval(this._timer);
          this._timer = null;
        }

        if (value) {
          // disable network on the buffer queue until we know we're online
          this.queue.setOnline(false); // perform an initial connectivity check

          this.checkStatus(); // schedule periodic connectivity checks

          this._timer = setInterval(this.checkStatus.bind(this), 10000);
          this.setAutoFlush(true);
        } else {
          this.setAutoFlush(false);
        }

        this.trigger('afterSetEnabled');
      }
    }]);

    return AnalyticsReporter;
  }(EventDispatcher);

  /**
   * Track an event for springroll Learning
   * @method onLearningEvent
   * @param {event} event The bellhop learningEvent
   * @private
   */

  var onLearningEvent = function onLearningEvent(event) {
    var data = event.data; // Send to the logging service if it's installed

    if (this.loggingService) {
      this.loggingService.send('pt-event', data);
    } // Automatically track with analytics


    this.analyticsReporter.pushEvent(data);
    /**
     * Event when dispatching a Learning Dispatcher event
     * @event learningEvent
     * @param {object} data The event data
     */

    this.trigger('learningEvent', data);
  };

  var AnalyticsReporterPlugin =
  /*#__PURE__*/
  function () {
    function AnalyticsReporterPlugin() {
      _classCallCheck(this, AnalyticsReporterPlugin);

      springroll.ContainerPlugin.call(this); // The Container Plugin constructor assigns the setup methods directly to the instance, so we have to overwrite
      // that with our methods

      this.setup = AnalyticsReporterPlugin.prototype.setup;
      this.open = AnalyticsReporterPlugin.prototype.open;
      this.close = AnalyticsReporterPlugin.prototype.close;
      this.teardown = AnalyticsReporterPlugin.prototype.teardown;
    }

    _createClass(AnalyticsReporterPlugin, [{
      key: "setup",
      value: function setup() {
        /**
         * The Learning Analytics client for sending events. Reads the learningApiUrl from the Container options
         * If the learningApiUrl is not set in the container options, this constructor will throw an error
         * @property {PBS.KIDS.AnalyticsReporter} analyticsReporter
         */
        this.analyticsReporter = new AnalyticsReporter(this.options.learningApiUrl);
      }
    }, {
      key: "open",
      value: function open() {
        // Enable the analytics dispatcher if we're in production mode
        this.analyticsReporter.enabled = true;
        var learningHandler = onLearningEvent.bind(this); // Client is setup, listen for learning event

        this.client.on('learningEvent', learningHandler);
      }
    }, {
      key: "close",
      value: function close() {
        if (this.analyticsReporter) {
          this.analyticsReporter.enabled = false;
          this.client.off('learningEvent');
        }
      }
    }, {
      key: "teardown",
      value: function teardown() {
        if (this.analyticsReporter) {
          this.analyticsReporter.destroy();
          delete this.analyticsReporter;
        }
      }
    }]);

    return AnalyticsReporterPlugin;
  }();

  var platform = new Platform(); // Instantiate the plugin, which will automatically register it in the springroll.Container class
  // eslint-disable
  // Instantiate analytics reporter plugin if we are not on ie 11

  if (platform.isIE11() === false) {
    new AnalyticsReporterPlugin();
  }

}());
